﻿B4J=true
Group=Pages
ModulesStructureVersion=1
Type=Class
Version=7.8
@EndOfDesignText@
'BANano compatible ONLY code. You can not use typical B4J libraries here.  Use their BANano version (if it exists)
'Making changes in a this module/class in B4J debug mode will NOT have any effect until recompiled!
#Region BANano 
	' <-------------- IMPORTANT! This is because we want this module to be transpiled by BANano 
#End Region

Sub Class_Globals
	Private BANano As BANano 'ignore
	Private ws As BANanoWebSocket
	' a class used by both the SERVER and the BROWSER
	Private Human As SHAREDHuman	
	' BANano Custom View objects that are on the UploadForm layout
	Private SKButton1 As SKButton 'ignore
	Private SKTextBox1 As SKTextBox 'ignore
	Private SKLabel1 As SKLabel 'ignore
End Sub

'Initializes the object. You can NOT add extra parameters!
Public Sub Initialize
	' does the browser support websockets?
	If ws.IsSupported Then
		' here we connect to our SERVERAbout websocket class using the 'classic' B4J Websocket events WebSocket_Connected and WebSocket_Disconnected
		ws.Initialize("ws://" & BANano.Location.GetHost & "/ws/" & BANano.StaticFolder & "/about")
	End If
	Human.Initialize
End Sub

' Server says socket is ready
Sub WebSocket_Connected()
	Log("Connected ===> My B4J PageId: " & BANano.GetPageID)
	Log("Testing WatchLive")
	' load de layoout for the upload
	BANano.LoadLayout("#body", "UploadForm")
	
	' running a method on the server and wait for the result
	Dim value As Int = 0
	Dim prom As BANanoPromise = ws.RunFunctionWithResult("AddOnTheServer", Array(3 , 6))
	prom.Then(value)
		Log("SERVER says sum of 3+6=" & value)
	prom.end
	
	' get the human class from the server
	Dim humanJson As String
	Dim promHuman As BANanoPromise = ws.RunFunctionWithResult("GetHuman", Null)
	promHuman.Then(humanJson)
		Human.FromJson(humanJson)
		' making a change
		Human.Name = "Alain Bailleul"
		' and sending it back to the server
		ws.RunFunction("SetHuman", Array(Human.ToJSON))
		Log("Hello Human " & Human.Name & " (" & Human.Gender & ")")
	promHuman.end
	
	' note that this will be logged BEFORE the sum and the Human retrieval.  If you want it AFTER then it has to be put inside the Promise
	ws.RunFunction("SERVERTest", Array("Hello from the BROWSER!"))

	' get some assets from the server/internet
	Dim Files As List = Array("./assets/B4X.jpg", "https://jsonplaceholder.typicode.com/posts", "./assets/UTF8.txt")
	Dim responses() As String
	Dim dataUrlProm As BANanoPromise = BANano.GetFileAsDataURL(Files.Get(0), Null)
	Dim jsonObjProm As BANanoPromise = BANano.GetFileAsJSON(Files.Get(1), Null)
	Dim textProm As BANanoPromise = BANano.GetFileAsText(Files.Get(2), Null, "UTF-8")
	' return when all 3 promises are done
	Dim prom As BANanoPromise = BANano.PromiseAll(Array(dataUrlProm, jsonObjProm, textProm))
	prom.Then(responses)
		For i = 0 To responses.Length - 1
			Log(Files.Get(i) & ":")
			Log(responses(i))
		Next
	prom.end	
End Sub

Sub WebSocket_Disconnected(event As BANanoEvent)
	Log("Websocket closed")
End Sub

' called from the SERVER
public Sub AddInTheBrowser(first As Int, second As Int) As Int
	Return first + second
End Sub

' called from the SERVER
public Sub BROWSERTest(msg As String)
	Log("SERVER says '" & msg & "'")
End Sub

' uploading a file to our server
Sub SKButton1_Click (event As BANanoEvent)
	Dim Response As BANanoObject
	' get the file object
	Dim theFile As BANanoObject = SKTextBox1.File
	If theFile = Null Then
		BANano.Alert("Please select a file first!")
		Return
	End If
	' prevent big uploads
	If theFile.GetField("size") > 1024 * 1024 * 5 Then
		BANano.Alert("File is to big!")
		Return
	End If
	' returns a promise
	Dim prom As BANanoPromise = BANano.UploadFile(theFile)
	prom.Then(Response)
		SKLabel1.Text = "Upload status: " & Response.GetField("status").Result
	prom.Else(Response)
		Log(Response)
	prom.end
End Sub


