﻿B4J=true
Group=Pages
ModulesStructureVersion=1
Type=Class
Version=7.8
@EndOfDesignText@
' B4J compatible ONLY code, no BANano allowed.
'WebSocket class
Sub Class_Globals
	Private ws As WebSocket
	Private CacheReport As BANanoCacheReport	
	' a class used by both the SERVER and the BROWSER
	Private Human As SHAREDHuman
End Sub

Public Sub Initialize
	Human.Initialize
End Sub

Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
	Log("Connected")
	
	ws = WebSocket1
	
	' Lets update the cache with this class
	CacheReport = Main.Server.UpdateFromCache(Me, ws)
	Log("PageID: " & CacheReport.BANPageID)
	Log("Comes From Cache:" & CacheReport.ComesFromCache)
	Log("Is a reconnecting socket: " & CacheReport.IsReconnected)
	
	' We can already send stuff to the browser, using normal B4J jServer code with Future
	Dim fut As Future = ws.RunFunctionWithResult("AddInTheBrowser", Array(20, 30))
	ws.Flush
	Log("BROWSER says sum of 20+30=" & fut.Value)
	
	' or if no result is expected back
	ws.RunFunction("BROWSERTest", Array("Hello from the SERVER!"))
	ws.Flush
		
	' IMPORTANT lets tell the browser we are ready to receive call from the browser
	' Uses the classic WebSocket_Connected and WebSocket_DisConnected events on the browser size
	' Use Main.Server.SendReady(ws, "ws") if you use the advanced events OnOpen, OnMessage, OnServerReady, ...
	Main.server.SendConnected(ws)	
End Sub

Private Sub WebSocket_Disconnected
	Log("disconnected")
End Sub

' event raised to distribute incoming events coming from the BROWSER
public Sub BANano_ParseEvent(params As Map)
	Main.Server.ParseEvent(Me, ws, CacheReport.BANPageID, CacheReport.BANSessionID, params)
End Sub
' event raised when a file has been uploaded
public Sub BANano_Uploaded(status As Int, fileName As String)
	Log(fileName & " = " & status)
	Select Case status
		Case 200 ' OK
		Case 500 ' was not a POST call
		Case 501 ' file to big
		Case 502 ' file type not allowed
	End Select
End Sub

' called from the BROWSER
public Sub AddOnTheServer(first As Int, second As Int) As Int
	Log("First: " & first)
	Log("Second: " & second)	
	Return first + second
End Sub

' called from the BROWSER
public Sub SERVERTest(msg As String)
	Log("BROWSER says '" & msg & "'")
End Sub

' called from the BROWSER
public Sub GetHuman() As String
	' make a human that the browser can retrieve
	Human.Name = "Alain"
	Human.Gender = "Male"
	Return Human.ToJSON
End Sub

' called from the BROWSER
public Sub SetHuman(HumanStr As String)
	Human.FromJson(HumanStr)
	Log("Human.Name (changed in the browser) is " & Human.Name)
End Sub
