﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=6.78
@EndOfDesignText@
#IgnoreWarnings: 12

Sub Process_Globals
	
	Private BANano As BANano 'ignore
	
	Dim LeafletMap As BANanoLeafletMap

	Dim myMarkerMap As Map

	Dim myButton As BANanoElement

	Dim RandomMarkerNumber As Int = 50

	Dim ZoomedIn As Boolean = False

End Sub

Sub Init()
	
	myMarkerMap.Initialize

	BANano.GetElement("#DemoContainer").Empty
	
	BANano.GetElement("#DemoContainer").Append("<h1>ClusteredMarkers - Demo</h1>")

	LeafletMap.Initialize("#DemoContainer")
	
	LeafletMap.SetStyle($"{ "width": "800px", "height": "600px" }"$)
	
	' add a TileLayer...

	Dim TileLayer As BANanoLeafletTileLayer
	
	TileLayer.Initialize
	
	LeafletMap.AddTileLayer(TileLayer)
	
	LeafletMap.PanTo(50.703416, 6.634032)

	' add a MarkerClusterGroup...

	Dim MarkerClusterGroup As BANanoLeafletMarkerClusterGroup
	
	MarkerClusterGroup.Initialize
	
	' ... set the cluster-radius
	MarkerClusterGroup.SetMaxClusterRadius(100)
	
	' ... populate it with random markers
	Populate(MarkerClusterGroup)

	' ... And add it To the map:
	LeafletMap.AddMarkerClusterGroup(MarkerClusterGroup)
	
	
	BANano.GetElement("#DemoContainer").Append("<button id='myButton' />")

	myButton = BANano.GetElement("#myButton")
	
	myButton.SetStyle($"{ "width": "200px", "height": "30px", "margin-top": "10px" }"$)
	
	myButton.SetText("Zoom to Marker " + RandomMarkerNumber)
	
	myButton.On("click", Me, "buttonclick")

End Sub

Sub GetRandomLatLng(myMap As BANanoLeafletMap) As BANanoLeafletLatLng
	
	Dim ReturnValue As BANanoLeafletLatLng
	
	Dim Bounds As BANanoLeafletLatLngBounds = myMap.GetBounds()
	
	Dim SouthWest As BANanoLeafletLatLng = Bounds.GetSouthWest()
	Dim NorthEast As BANanoLeafletLatLng = Bounds.GetNorthEast()

	Dim lngSpan As Double = NorthEast.GetLng() - SouthWest.GetLng()
	Dim latSpan As Double = NorthEast.GetLat() - SouthWest.GetLat()

	Dim rv1 As Double = BANano.RunJavascriptMethod("Math.random", Null)
	Dim rv2 As Double = BANano.RunJavascriptMethod("Math.random", Null)
	
	Dim la1 As Double = (SouthWest.GetLat() + latSpan * rv1 )
	Dim la2 As Double = (SouthWest.GetLng() + lngSpan * rv2 )
	
	ReturnValue.Initialize( la1 , la2 )
	
	Return ReturnValue
	
End Sub

Sub Populate(myMarkerClusterGroup As BANanoLeafletMarkerClusterGroup)
  
	' Populate the Map with random markers
  
	Dim Counter As Int
  
	For Counter = 0 To 100
    
		Dim myMarker As BANanoLeafletMarker
		
		myMarker.Initialize3(GetRandomLatLng(LeafletMap))
		
		myMarker.SetPopup("Random Marker: " & Counter)
		myMarker.SetTooltip("Random Marker: " & Counter)
    
		myMarkerClusterGroup.AddMarker(myMarker)

		myMarkerMap.Put("M" + Counter, myMarker)

	Next
  
End Sub

Sub ButtonClick()
  
	If ZoomedIn Then
    
		RandomMarkerNumber = Rnd(0, 100)
    
		myButton.SetText("Zoom to Marker " + RandomMarkerNumber)
    
		Dim LatLng As BANanoLeafletLatLng
		LatLng.Initialize(50.703416, 6.634032)
		LeafletMap.SetView2(LatLng, 5)
		 
		ZoomedIn = False
    
	Else
    
		myButton.SetText("Zoom out")
    
		Dim myMarker As BANanoLeafletMarker
		myMarker = myMarkerMap.Get("M"+ RandomMarkerNumber)
		LeafletMap.SetView2(myMarker.GetLatLng(), 8)
		
		ZoomedIn = True
    
	End If
  
End Sub