﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=6.78
@EndOfDesignText@
#IgnoreWarnings: 12

Sub Process_Globals
	
	Private BANano As BANano 'ignore
	
	Dim LeafletMap As BANanoLeafletMap
	Dim LayerGroup As BANanoLeafletLayerGroup

	Dim txtSearch As BANanoElement
	Dim cmdSearch As BANanoElement
	Dim lstSearchResult As BANanoElement
	
End Sub

Sub Init()

	BANano.GetElement("#DemoContainer").Empty

	BANano.GetElement("#DemoContainer").Append("<h1>Nominatim-Demo</h1>")
	
	BANano.GetElement("#DemoContainer").Append("<input type='text' id='txtSearch' />")
	txtSearch = BANano.GetElement("#txtSearch")
	txtSearch.SetValue("Mississippi")
	txtSearch.SetStyle($"{ "width": "500px", "height": "30px", "margin": "10px" }"$)
	
	BANano.GetElement("#DemoContainer").Append("<button id='cmdSearch' />")
	cmdSearch = BANano.GetElement("#cmdSearch")
	cmdSearch.SetStyle($"{ "width": "200px", "height": "30px", "margin": "10px" }"$)
	cmdSearch.SetText("Search")
	cmdSearch.On("click", Me, "buttonsearchclick")

	BANano.GetElement("#DemoContainer").Append("<br />")
	
	BANano.GetElement("#DemoContainer").Append("<select size='5' id='lstSearchResult' />")
	lstSearchResult = BANano.GetElement("#lstSearchResult")
	lstSearchResult.SetStyle($"{ "width": "800px" }"$)


	' ###################	
	
	LeafletMap.Initialize("#DemoContainer")
	
	LeafletMap.SetStyle($"{ "width": "800px", "height": "600px" }"$)

	' add a TileLayer...

	Dim TileLayer As BANanoLeafletTileLayer
	TileLayer.Initialize
	LeafletMap.AddTileLayer(TileLayer)
	LeafletMap.PanTo(48.856613, 2.352222)
	LeafletMap.SetZoom(5)

	' add a LayerGroup
	LayerGroup.Initialize
	LeafletMap.AddLayerGroup(LayerGroup)

End Sub

Sub lstSearchResultEvent(Event As BANanoEvent)
	
	Dim SelectedElement As BANanoElement
	
	SelectedElement = BANano.GetElement("#" & Event.ID)
	
	Dim JP As BANanoJSONParser

	JP.Initialize(SelectedElement.GetData("mapdata"))

	Dim myMap As Map
	myMap.Initialize
	myMap = JP.NextObject

	LayerGroup.ClearLayers
	
	Select myMap.Get("class")
        
		Case "boundary", "highway", "waterway", "way"
			
			' in this case we need a GeoJSONLayer
			
			Dim myGeoJSONLayer As BANanoLeafletGeoJSONLayer
			myGeoJSONLayer.Initialize
			myGeoJSONLayer.AddData(myMap.Get("geojson")) ' the data is stored in geojson
			LayerGroup.AddGeoJSONLayer(myGeoJSONLayer)
			LeafletMap.FitBounds(myGeoJSONLayer.GetBounds)
			
		Case Else ' Case "place", "amenity", "building", "highway"
		
			' in any other case we use a marker
		
			Dim myMarker As BANanoLeafletMarker
			myMarker.Initialize2(myMap.Get("lat"), myMap.Get("lon"))
			LayerGroup.AddMarker(myMarker)
			LeafletMap.SetView(myMap.Get("lat"), myMap.Get("lon"), 18)
			
	End Select
	
End Sub

Sub ButtonSearchClick(Event As BANanoEvent)
	
	If txtSearch.GetValue = "" Then
		Return
	End If
	
	Dim Headers As Map
	Headers.Initialize
	
	BANano.CallAjax("https://nominatim.openstreetmap.org/search?polygon_geojson=1&format=json&q=" & EncodeURI(txtSearch.GetValue), "GET", "", "", "Search", False, Headers)
	
End Sub
 
Sub EncodeURI(uri As String) As String
	Return BANano.RunJavascriptMethod("encodeURI", Array(uri))
End Sub
 
Sub JsonStringify(O As Object) As String
	Return BANano.RunJavascriptMethod("JSON.stringify", Array(O))
End Sub
 
Sub Leaflet_CallAjaxResult(Success As Boolean, UniqueID As String, Result As String)

	lstSearchResult.Empty

	If Success = True Then
	
		Dim JP As BANanoJSONParser
		JP.Initialize(Result)

		Dim myMap1 As Map
		myMap1.Initialize
		myMap1 = JP.NextArray
	
		Dim MapCounter As Int
	
		For MapCounter = 0 To myMap1.Size - 1
		
			Dim myMap2 As Map
			myMap2.Initialize
			myMap2 = myMap1.GetValueAt(MapCounter)

			lstSearchResult.Append("<option id='pid_" & myMap2.Get("place_id") & "'>" & myMap2.Get("display_name") & "</option>")

			BANano.GetElement("#pid_" & myMap2.Get("place_id")).SetData("mapdata", JsonStringify(myMap2))

			BANano.GetElement("#pid_" & myMap2.Get("place_id")).On("click", Me, "lstsearchresultevent")

		Next
	
	End If
	
End Sub
