﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.78
@EndOfDesignText@
#IgnoreWarnings: 12

Sub Class_Globals
	
	Dim BANano As BANano 'ignore
	
	Dim MapObject As BANanoObject
	
	Dim L As BANanoObject
	
End Sub

'
'Initializes the map.
'TargetID: The ID of an existing HTML element in which a DIV-Element is created.
'If TargetID is empty, the DIV is created in the BODY-Element.
'The DIV-Element contains after the initialization the map.
Sub Initialize(TargetID As String)

	L.Initialize("L")
	
	If TargetID = "" Then
		TargetID = "body"
	End If
	
	Dim B() As BANanoElement = BANano.GetElement(TargetID).Append("<div />").Children("")
	
	BindMap(B(B.Length-1))
	
End Sub

'
'Initializes the map with an existent BANanoElement.
Sub Initialize2(bElement As BANanoElement)
	BindMap(bElement)
End Sub

'
'Initializes the map with an existent HTML-Element.
Sub Initialize3(targetID As String)
	Dim bElement As BANanoElement = BANano.GetElement(targetID)
	BindMap(bElement)
End Sub

'
Private Sub BindMap(bElement As BANanoElement)
		
	If bElement.ToObject.GetField("extraData") = BANano.UNDEFINED Then
		Dim m As Map
		bElement.ToObject.SetField("extraData",m)
	End If
	
	MapObject = bElement.ToObject.GetField("extraData").GetField("storedMap")
	
	If MapObject <> BANano.UNDEFINED Then
		MapObject.RunMethod("remove", Null)
		bElement.Empty
	End If
		
	MapObject = L.RunMethod("map", Array(bElement.ToObject, CreateMap("center": Array(0, 0), "zoom": 5)))
	
	bElement.ToObject.GetField("extraData").SetField("storedMap", MapObject)

End Sub

'
'Sets the CSS-Style of the HTML-Element, that contains the Map.
Sub SetStyle(JsonString As String)
	BANano.ToElement(MapObject.RunMethod("getContainer", Null)).SetStyle(JsonString)
End Sub

'
'Adds a Marker to the map.
Sub AddMarker(Marker As BANanoLeafletMarker)
	Marker.MarkerObject.RunMethod("addTo", MapObject)
End Sub

'
'Removes a Marker from the map.
Sub RemoveMarker(Marker As BANanoLeafletMarker)
	MapObject.RunMethod("removeLayer", Marker.MarkerObject)
End Sub

'
'Adds a TileLayer to the map.
Sub AddTileLayer(TileLayer As BANanoLeafletTileLayer)
	TileLayer.TileLayerObject.RunMethod("addTo", MapObject)
End Sub

'
'Adds a LayerGroup to the map.
Sub AddLayerGroup(LayerGroup As BANanoLeafletLayerGroup)
	LayerGroup.LayerGroupObject.RunMethod("addTo", MapObject)
End Sub

'
'Adds a MarkerClusterGroup to the map.
Sub AddMarkerClusterGroup(MarkerClusterGroup As BANanoLeafletMarkerClusterGroup)
	MarkerClusterGroup.MarkerClusterGroupObject.RunMethod("addTo", MapObject)
End Sub

'
'Adds a FeatureGroup to the map.
Sub AddFeatureGroup(FeatureGroup As BANanoLeafletFeatureGroup)
	FeatureGroup.FeatureGroupObject.RunMethod("addTo", MapObject)
End Sub

'
'Adds a GeoJSONLayer to the map.
Sub AddGeoJSONLayer(GeoJSONLayer As BANanoLeafletGeoJSONLayer)
	GeoJSONLayer.GeoJSONLayerObject.RunMethod("addTo", MapObject)
End Sub

'
'Pans the map to a given center (Lat/Lng).
Sub PanTo(Lat As Double, Lng As Double)
	MapObject.RunMethod("panTo", L.RunMethod("latLng", Array(Lat, Lng)))
End Sub

'
'Pans the map to a given center (LatLng-Object).
Sub PanTo2(LatLng As BANanoLeafletLatLng)
	MapObject.RunMethod("panTo", LatLng.LatLngObject)
End Sub

'
'Sets a map view that contains the given geographical
'bounds with the maximum zoom level possible.
Sub FitBounds(LatLngBounds As BANanoLeafletLatLngBounds)
	MapObject.RunMethod("fitBounds", LatLngBounds.LatLngBoundsObject)
End Sub

'
'Returns the geographical bounds visible in the current map view.
Sub GetBounds() As BANanoLeafletLatLngBounds
	Dim ReturnValue As BANanoLeafletLatLngBounds
	ReturnValue.LatLngBoundsObject = MapObject.RunMethod("getBounds", Null)
	Return ReturnValue
End Sub

'
'Sets the view of the map (geographical center (Lat/Lng) and zoom).
Sub SetView(Lat As Double, Lng As Double, Zoom As Int)
	MapObject.RunMethod("setView", Array(L.RunMethod("latLng", Array(Lat, Lng)), Zoom))
End Sub

'
'Sets the view of the map (geographical center (LatLngObject) and zoom).
Sub SetView2(LatLng As BANanoLeafletLatLng, Zoom As Int)
	MapObject.RunMethod("setView", Array(LatLng.LatLngObject, Zoom))
End Sub

'
'ToDo: Sets the view of the map (geographical center and zoom) with the given animation options.
Sub SetView3(LatLng As BANanoLeafletLatLng, Zoom As Int, AnimationOptions As Object)
	' ToDo
End Sub

'
'Sets the zoom of the map.
Sub SetZoom(Zoom As Int)
	MapObject.RunMethod("setZoom", Zoom)
End Sub

'
'Binds an Event to the map.
Sub BindEvent(Event As String, EventHandler As Object, Callback As String)
	BANano.ToElement(MapObject).On(Event.ToLowerCase, EventHandler, Callback.ToLowerCase)
End Sub

'
'Unbinds a Event from the map.
Sub UnbindEvent(Event As String, EventHandler As Object, Callback As String)
	BANano.ToElement(MapObject).Off(Event.ToLowerCase)
End Sub