﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.78
@EndOfDesignText@
#IgnoreWarnings: 9
#IgnoreWarnings: 10
#IgnoreWarnings: 12

Sub Class_Globals
	
	Dim BANano As BANano 'ignore
	
	Dim MarkerObject As BANanoObject
	
	Dim L As BANanoObject
	
End Sub

'Initializes the marker with the coordinates 0, 0
Public Sub Initialize
	L.Initialize("L")
	MarkerObject = L.RunMethod("marker", Array(0, 0))
End Sub

'Initializes the marker based on a Latitude- and a Longitude-Coordinate
Public Sub Initialize2(Lat As Double, Lng As Double)
	L.Initialize("L")
	MarkerObject = L.RunMethod("marker", Array(Array(Lat, Lng)))
End Sub

'Initializes the marker based on a LatLng-Object
Public Sub Initialize3(LatLng As BANanoLeafletLatLng)
	L.Initialize("L")
	MarkerObject = L.RunMethod("marker", LatLng.LatLngObject)
End Sub

'Initializes the marker based on an EventTarget-Object
Public Sub Initialize4(EventTarget As Object)
	L.Initialize("L")
	MarkerObject = EventTarget
End Sub

'Whether the marker is draggable with mouse/touch or not.
Public Sub SetDraggable(Draggable As Boolean)
	MarkerObject.GetField("options").SetField("draggable", Draggable)
End Sub

'Whether to pan the map when dragging this marker near its edge or not.
Public Sub SetAutoPan(AutoPan As Boolean)
	MarkerObject.GetField("options").SetField("autoPan", AutoPan)
End Sub

'Sets the tooltip of this marker
Public Sub SetTooltip(Tooltip As String)
	If Tooltip = "" Then
		MarkerObject.RunMethod("unbindTooltip", Null)
	Else
		MarkerObject.RunMethod("bindTooltip", Tooltip)
	End If
End Sub
	
'Sets the popup of this marker
Public Sub SetPopup(Popup As String)
	If Popup = "" Then
		MarkerObject.RunMethod("unbindPopup", Null)
	Else	
		MarkerObject.RunMethod("bindPopup", Popup)
	End If
End Sub

'Returns the bounds of this marker
Public Sub GetBounds() As BANanoLeafletLatLngBounds
	Dim ReturnValue As BANanoLeafletLatLngBounds
	ReturnValue.LatLngBoundsObject = L.RunMethod("latLngBounds", Array(MarkerObject.RunMethod("getLatLng", Null)))
	Return ReturnValue
End Sub

'Returns the LatLng-Object of this marker
Public Sub GetLatLng() As BANanoLeafletLatLng
	Dim ReturnValue As BANanoLeafletLatLng
	ReturnValue.LatLngObject = MarkerObject.RunMethod("getLatLng", Null)
	Return ReturnValue
End Sub

'Binds an Event
Public Sub BindEvent(Event As String, EventHandler As Object, Callback As String)
	BANano.ToElement(MarkerObject).On(Event.ToLowerCase, EventHandler, Callback.ToLowerCase)
End Sub

'Unbinds an Event
Public Sub UnbindEvent(Event As String, EventHandler As Object, Callback As String)
	BANano.ToElement(MarkerObject).Off(Event.ToLowerCase)
End Sub