﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8
@EndOfDesignText@
'Custom BANano View class

'Uncomment the events you want to show to the user and implement the HandleEvents in DesignerCreateView 
'#Event: Focus (event As BANanoEvent)
'#Event: Blur (event As BANanoEvent)
'#Event: Resize (event As BANanoEvent)
'#Event: Scroll (event As BANanoEvent)
'#Event: Keydown (event As BANanoEvent)
'#Event: KeyPress (event As BANanoEvent)
'#Event: KeyUp (event As BANanoEvent)
#Event: Click (clickedIndex as int)
'#Event: ContextMenu (event As BANanoEvent)
'#Event: Dblclick (event As BANanoEvent)
'#Event: MouseDown (event As BANanoEvent)
'#Event: MouseEnter (event As BANanoEvent)
'#Event: MouseLeave (event As BANanoEvent)
'#Event: MouseMove (event As BANanoEvent)
'#Event: MouseOver (event As BANanoEvent)
'#Event: MouseOut (event As BANanoEvent)
'#Event: MouseUp (event As BANanoEvent)
'#Event: Wheel (event As BANanoEvent)
'#Event: Drag (event As BANanoEvent)
'#Event: DragEnd (event As BANanoEvent)
'#Event: DragEnter (event As BANanoEvent)
'#Event: DragStart (event As BANanoEvent)
'#Event: DragLeave (event As BANanoEvent)
'#Event: DragOver (event As BANanoEvent)
'#Event: Drop (event As BANanoEvent)
'#Event: TouchCancel (event As BANanoEvent)
'#Event: TouchEnd (event As BANanoEvent)
'#Event: TouchEnter (event As BANanoEvent)
'#Event: TouchLeave (event As BANanoEvent)
'#Event: TouchMove (event As BANanoEvent)
'#Event: TouchStart (event As BANanoEvent)
'#Event: Change (event As BANanoEvent)

' Properties that will be show in the ABStract Designer.  They will be passed in the props map in DesignerCreateView (Case Sensitive!)
#DesignerProperty: Key: Classes, DisplayName: Classes, FieldType: String, DefaultValue: , Description: Classes added to the HTML tag.
#DesignerProperty: Key: Style, DisplayName: Style, FieldType: String, DefaultValue: , Description: Styles added to the HTML tag. Must be a json String.
#DesignerProperty: Key: MarginLeft, DisplayName: Margin Left, FieldType: String, DefaultValue: , Description: Margin Left
#DesignerProperty: Key: MarginRight, DisplayName: Margin Right, FieldType: String, DefaultValue: , Description: Margin Right
#DesignerProperty: Key: MarginTop, DisplayName: Margin Top, FieldType: String, DefaultValue: , Description: Margin Top
#DesignerProperty: Key: MarginBottom, DisplayName: Margin Bottom, FieldType: String, DefaultValue: , Description: Margin Bottom
#DesignerProperty: Key: PaddingLeft, DisplayName: Padding Left, FieldType: String, DefaultValue: , Description: Padding Left
#DesignerProperty: Key: PaddingRight, DisplayName: Padding Right, FieldType: String, DefaultValue: , Description: Padding Right
#DesignerProperty: Key: PaddingTop, DisplayName: Padding Top, FieldType: String, DefaultValue: , Description: Padding Top
#DesignerProperty: Key: PaddingBottom, DisplayName: Padding Bottom, FieldType: String, DefaultValue: , Description: Padding Bottom
#DesignerProperty: Key: Enabled, DisplayName: Enabled, FieldType: Boolean, DefaultValue: True, Description: If enabled.
#DesignerProperty: Key: Visible, DisplayName: Visible, FieldType: Boolean, DefaultValue: True, Description: If visible.

#DesignerProperty: Key: Flavor, DisplayName: Flavor, FieldType: String, DefaultValue: plain, List: plain|button-primary, Description: Button flavor.
#DesignerProperty: Key: Text, DisplayName: Text, FieldType: String, DefaultValue: , Description: Text on the label
#DesignerProperty: Key: Width, DisplayName: Full Width, FieldType: Boolean, DefaultValue: True, Description: Set the width 100% 
Sub Class_Globals
	Private BANano As BANano 'ignore
	Private S As SKShared
	Private mName As String 'ignore
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mTarget As BANanoElement 'ignore
	Private mElement As BANanoElement 'ignore
	Private mElementBtn As BANanoElement 'ignore
	Private mElementWrap As BANanoElement 'ignore
	Private mElementUl As BANanoElement 'ignore
		
	Private mClasses As String = ""
	Private mStyle As String = ""
	Public MarginLeft As String = ""
	Public MarginRight As String = ""
	Public MarginTop As String = ""
	Public MarginBottom As String = ""
	Public PaddingLeft As String = ""
	Public PaddingRight As String = ""
	Public PaddingTop As String = ""
	Public PaddingBottom As String = ""
	Private mVisible As Boolean = True
	Private mEnabled As Boolean = True
	
	Private mFlavor As String = ""
	Private mText As String = ""
	Private mWidth As Boolean = False
	Private mExtraWidth As String = ""
	
	Private mListElements As List			
End Sub

Public Sub Initialize (CallBack As Object, Name As String, EventName As String)
	mName = Name.ToLowerCase
	mEventName = EventName.ToLowerCase
	mCallBack = CallBack
	S.Initialize(Me)
End Sub

' returns the BANanoElement
public Sub getElement() As BANanoElement
	Return mElement
End Sub

' returns the tag id
public Sub getID() As String
	Return mName
End Sub

' this is the place where you create the view in html and run initialize javascript.  Must be Public!
Public Sub DesignerCreateView (Target As BANanoElement, Props As Map)
	mTarget = Target

	If Props <> Null Then
		' set common properties
		S.SetProps(Props)
		' set component specific properties
		mFlavor = Props.Get("Flavor")
		mText = Props.Get("Text")
		mWidth = Props.Get("Width")
	End If
	
	Dim exStyle As String = BuildExStyle
	
	If mFlavor = "plain" Then mFlavor = ""
	
	If mWidth Then
		mExtraWidth = "u-full-width"
	End If
	
	mListElements.Initialize
	
	mElement = mTarget.Append($"<label id="${mName}wrap" class="sk-dropdown ${mExtraWidth}"><div id="${mName}btn" class="sk-dd-button ${mExtraWidth} ${mFlavor} ${mClasses}" style="${exStyle}${mStyle}">${mText}</div><ul id="${mName}ul" class="sk-dd-menu ${mExtraWidth}""></ul></label>"$).Get("#" & mName & "inp")
	mElementBtn.Initialize("#" & mName & "btn")
	mElementWrap.Initialize("#" & mName & "wrap")
	mElementUl.Initialize("#" & mName & "ul")
		
	mElementBtn.HandleEvents("click", Me, "HandleOpenClose")
	
	setEnabled(mEnabled)
	setVisible(mVisible)
		
	' defining events is very simple. Note that it has to be run AFTER adding it to the HTML DOM! eventName must be lowercase!	
End Sub

public Sub AddToParent(targetID As String)
	mTarget = BANano.GetElement("#" & targetID.ToLowerCase)
	DesignerCreateView(mTarget, Null)
End Sub

public Sub Remove()
	mElementWrap.Remove
	BANano.SetMeToNull
End Sub

#Region common shared properties and methods
public Sub Trigger(event As String, params() As String)
	S.Trigger(mElement, event, params)
End Sub

public Sub BuildExStyle() As String
	Return S.BuildExStyle
End Sub

public Sub setClasses(Classes As String)
	S.SetClasses(mElementWrap, Classes)
End Sub

public Sub getClasses() As String
	Return S.GetClasses
End Sub

' must be a json string
' e.g. $"{ "width": "200px", "height": "200px", "background": "green", "border-radius": "5px" }"$
public Sub setStyle(Style As String)
	S.SetStyle(mElementWrap,Style)
End Sub

public Sub getStyle() As String
	Return S.GetStyle
End Sub

public Sub setVisible(Visible As Boolean)
	S.SetVisible(mElementWrap, Visible)
End Sub

public Sub getVisible() As Boolean
	Return S.GetVisible(mElementWrap)
End Sub

public Sub setEnabled(Enabled As Boolean)
	S.SetEnabled(mElementBtn, Enabled)	
End Sub

public Sub getEnabled() As Boolean
	Return S.GetEnabled(mElementBtn)
End Sub
#End Region

public Sub setText(text As String)
	If mElementBtn <> Null Then
		mElementBtn.SetHTML(BANano.SF(text))
	End If
	mText = text
End Sub

public Sub getText() As String
	Return mText
End Sub

public Sub AddItem(Text As String)
	Dim tmpElem As BANanoElement = mElementUl.Append($"<li id="${mName}_${mListElements.Size}">${Text}</li>"$).Get("#" & mName & "_" & mListElements.Size)
	tmpElem.HandleEvents("click", Me, "HandleClick")
	mListElements.Add(tmpElem)
End Sub

public Sub AddDivider()
	mElementUl.Append($"<li class="divider"></li>"$)
End Sub

#Region Internal Events
private Sub HandleClick(event As BANanoEvent) 'ignore
	If mEnabled Then
		Dim src As String = event.OtherField("srcElement").GetField("id").Result
		Dim j As Int = src.LastIndexOf("_")
		Dim CurrentItem As Int
		If j > 0 Then
			src = src.SubString(j+1)
			CurrentItem = BANano.parseInt(src)
			Dim tmpElem As BANanoElement = mListElements.Get(CurrentItem)
			Dim newText As String = tmpElem.GetText
			If mElementBtn.GetText = newText Then
				mElementUl.RemoveClass("sk-dd-open")
				Return
			End If
			mElementBtn.SetText(newText)	
			mElementUl.RemoveClass("sk-dd-open")
		End If
		
		BANano.CallSub(mCallBack, mEventName & "_click", Array(CurrentItem))
	End If
End Sub

private Sub HandleOpenClose(event As BANanoEvent) 'ignore
	If mEnabled Then
		If mElementUl.HasClass("sk-dd-open") Then
			mElementUl.RemoveClass("sk-dd-open")
		Else
			mElementUl.AddClass("sk-dd-open")
		End If
	End If
End Sub
#End Region
