﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8
@EndOfDesignText@
'Custom BANano View class

'Uncomment the events you want to show to the user and implement the HandleEvents in DesignerCreateView 
'#Event: Focus (event As BANanoEvent)
'#Event: Blur (event As BANanoEvent)
'#Event: Resize (event As BANanoEvent)
'#Event: Scroll (event As BANanoEvent)
'#Event: Keydown (event As BANanoEvent)
'#Event: KeyPress (event As BANanoEvent)
'#Event: KeyUp (event As BANanoEvent)
#Event: Click (buttonIndex as int)
'#Event: ContextMenu (event As BANanoEvent)
'#Event: Dblclick (event As BANanoEvent)
'#Event: MouseDown (event As BANanoEvent)
'#Event: MouseEnter (event As BANanoEvent)
'#Event: MouseLeave (event As BANanoEvent)
'#Event: MouseMove (event As BANanoEvent)
'#Event: MouseOver (event As BANanoEvent)
'#Event: MouseOut (event As BANanoEvent)
'#Event: MouseUp (event As BANanoEvent)
'#Event: Wheel (event As BANanoEvent)
'#Event: Drag (event As BANanoEvent)
'#Event: DragEnd (event As BANanoEvent)
'#Event: DragEnter (event As BANanoEvent)
'#Event: DragStart (event As BANanoEvent)
'#Event: DragLeave (event As BANanoEvent)
'#Event: DragOver (event As BANanoEvent)
'#Event: Drop (event As BANanoEvent)
'#Event: TouchCancel (event As BANanoEvent)
'#Event: TouchEnd (event As BANanoEvent)
'#Event: TouchEnter (event As BANanoEvent)
'#Event: TouchLeave (event As BANanoEvent)
'#Event: TouchMove (event As BANanoEvent)
'#Event: TouchStart (event As BANanoEvent)
'#Event: Change (event As BANanoEvent)

' Properties that will be show in the ABStract Designer.  They will be passed in the props map in DesignerCreateView (Case Sensitive!)
#DesignerProperty: Key: Classes, DisplayName: Classes, FieldType: String, DefaultValue: , Description: Classes added to the HTML tag.
#DesignerProperty: Key: Style, DisplayName: Style, FieldType: String, DefaultValue: , Description: Styles added to the HTML tag. Must be a json String.
#DesignerProperty: Key: MarginLeft, DisplayName: Margin Left, FieldType: String, DefaultValue: , Description: Margin Left
#DesignerProperty: Key: MarginRight, DisplayName: Margin Right, FieldType: String, DefaultValue: , Description: Margin Right
#DesignerProperty: Key: MarginTop, DisplayName: Margin Top, FieldType: String, DefaultValue: , Description: Margin Top
#DesignerProperty: Key: MarginBottom, DisplayName: Margin Bottom, FieldType: String, DefaultValue: , Description: Margin Bottom
#DesignerProperty: Key: PaddingLeft, DisplayName: Padding Left, FieldType: String, DefaultValue: , Description: Padding Left
#DesignerProperty: Key: PaddingRight, DisplayName: Padding Right, FieldType: String, DefaultValue: , Description: Padding Right
#DesignerProperty: Key: PaddingTop, DisplayName: Padding Top, FieldType: String, DefaultValue: , Description: Padding Top
#DesignerProperty: Key: PaddingBottom, DisplayName: Padding Bottom, FieldType: String, DefaultValue: , Description: Padding Bottom
#DesignerProperty: Key: Enabled, DisplayName: Enabled, FieldType: Boolean, DefaultValue: True, Description: If enabled.
#DesignerProperty: Key: Visible, DisplayName: Visible, FieldType: Boolean, DefaultValue: True, Description: If visible.

#DesignerProperty: Key: ButtonTexts, DisplayName: Button Texts, FieldType: String, DefaultValue: , Description: A ; delimted string with Button titles.
#DesignerProperty: Key: ButtonIcons, DisplayName: Button Icons, FieldType: String, DefaultValue: , Description: A ; delimted string with Button icons.
#DesignerProperty: Key: ActiveButton, DisplayName: Active Button index, FieldType: Int, DefaultValue: 0, Description: Index of the Button that is active.
#DesignerProperty: Key: TopBottom, DisplayName: Top or Bottom, FieldType: String, DefaultValue: bottom, List: top|bottom, Description: Position of the mobile nav.
Sub Class_Globals
	Private BANano As BANano 'ignore
	Private S As SKShared
	Private mName As String 'ignore
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mTarget As BANanoElement 'ignore
	Private mElement As BANanoElement 'ignore
	Private mElementContents As BANanoElement 'ignore
		
	Private mClasses As String = ""
	Private mStyle As String = ""
	Public MarginLeft As String = ""
	Public MarginRight As String = ""
	Public MarginTop As String = ""
	Public MarginBottom As String = ""
	Public PaddingLeft As String = ""
	Public PaddingRight As String = ""
	Public PaddingTop As String = ""
	Public PaddingBottom As String = ""
	Private mVisible As Boolean = True
	Private mEnabled As Boolean = True
		
	Private mButtonTexts As String = ""
	Private mButtonIcons As String = ""
	Private mButtonTopBottom As String = "bottom"
	Private mActiveButton As Int = 0
	Private mButtonElements() As BANanoElement
	Private mButtonContents() As BANanoElement
End Sub

Public Sub Initialize (CallBack As Object, Name As String, EventName As String)
	mName = Name.ToLowerCase
	mEventName = EventName.ToLowerCase
	mCallBack = CallBack
	S.Initialize(Me)
End Sub

' returns the BANanoElement
public Sub getElement() As BANanoElement
	Return mElement
End Sub

' returns the tag id
public Sub getID() As String
	Return mName
End Sub

' this is the place where you create the view in html and run initialize javascript
Public Sub DesignerCreateView (Target As BANanoElement, Props As Map)
	mTarget = Target

	If Props <> Null Then
		' set common properties
		S.SetProps(Props)
		' set component specific properties
		mButtonTexts = Props.Get("ButtonTexts")
		mButtonIcons = Props.Get("ButtonIcons")
		mActiveButton = Props.Get("ActiveButton")
		mButtonTopBottom = Props.Get("TopBottom")
	End If
	
	Dim exStyle As String = BuildExStyle
	
	Dim ButtonT As String
	Dim ButtonV As String
	Dim ButtonTexts() As String
	Dim ButtonIcons() As String
	Dim Active1 As String
	Dim Active2 As String
	ButtonTexts = BANano.Split(";", mButtonTexts)
	ButtonIcons = BANano.Split(";", mButtonIcons)
	For i = 0 To ButtonTexts.Length - 1
		Active1 = ""
		Active2 = ""
		If i = mActiveButton Then
			Active1 = "sk-mobile-content-active"
			Active2 = "sk-mobile-nav-item-active"
		End If
		ButtonT = ButtonT & $"<div id="${mName}content_${i}" class="sk-mobile-content ${Active1}"></div>"$
		ButtonV = ButtonV & $"[BANCLEAN]
			<div id="${mName}but_${i}" class="sk-mobile-nav-item ${Active2}">
				<div class="sk-mobile-nav-item-button">
					<i id="${mName}icon_${i}" class="sk-mobile-nav-item-icon ${ButtonIcons(i)}"><span id="${mName}but_${i}badge" class="navbadge"></span></i>
					${ButtonTexts(i)}					
				</div>		
			</div>
		"$		
	Next
	
	' if you start a SmartString with [BANCLEAN] then BANano will remove all enters, tabs, etc while Transpiling	
	If mButtonTopBottom = "top" Then
		mElement = mTarget.Append($"<nav id="${mName}" class="sk-mobile-nav sk-mobile-nav-top ${mClasses}" style="${exStyle}${mStyle}">${ButtonV}</nav>"$).Get("#" & mName)
		mElementContents = mTarget.Append($"<div id="${mName}contents" class="sk-mobile-contents sk-mobile-nav-contents-top">${ButtonT}</div>"$).Get("#" & mName & "contents")
	Else
		mElementContents = mTarget.Append($"<div id="${mName}contents" class="sk-mobile-contents">${ButtonT}</div>"$).Get("#" & mName & "contents")
		mElement = mTarget.Append($"<nav id="${mName}" class="sk-mobile-nav sk-mobile-nav-bottom ${mClasses}" style="${exStyle}${mStyle}">${ButtonV}</nav>"$).Get("#" & mName)
	End If
	
	setEnabled(mEnabled)
	setVisible(mVisible)
	
	'' defining events is very simple. Note that it has to be run AFTER adding it to the HTML DOM! eventName must be lowercase!
	mButtonElements = mElement.Children("div.sk-mobile-nav-item")
	For i = 0 To mButtonElements.Length - 1
		mButtonElements(i).HandleEvents("click", Me, "handleclick")
	Next
	mButtonContents = mElementContents.Children("div.sk-mobile-content")
End Sub

public Sub AddToParent(targetID As String)
	mTarget = BANano.GetElement("#" & targetID.ToLowerCase)
	DesignerCreateView(mTarget, Null)
End Sub

public Sub Remove()
	mElement.Remove
	mElementContents.Remove
	BANano.SetMeToNull
End Sub

#Region common shared properties and methods
public Sub Trigger(event As String, params() As String)
	S.Trigger(mElement, event, params)
End Sub

public Sub BuildExStyle() As String
	Return S.BuildExStyle
End Sub

public Sub setClasses(Classes As String)
	S.SetClasses(mElement, Classes)
End Sub

public Sub getClasses() As String
	Return S.GetClasses
End Sub

' must be a json string
' e.g. $"{ "width": "200px", "height": "200px", "background": "green", "border-radius": "5px" }"$
public Sub setStyle(Style As String)
	S.SetStyle(mElement,Style)
End Sub

public Sub getStyle() As String
	Return S.GetStyle
End Sub

public Sub setVisible(Visible As Boolean)
	S.SetVisible(mElement, Visible)
End Sub

public Sub getVisible() As Boolean
	Return S.GetVisible(mElement)
End Sub

public Sub setEnabled(Enabled As Boolean)
	S.SetEnabled(mElement, Enabled)
End Sub

public Sub getEnabled() As Boolean
	Return S.GetEnabled(mElement)
End Sub
#End Region

public Sub GetButtonContents(index As Int) As BANanoElement
	Return mButtonContents(index)
End Sub

public Sub GetButton(index As Int) As BANanoElement
	Return mButtonElements(index)
End Sub

public Sub GetButtonBadge(index As Int) As String
	Dim tmpButton As BANanoElement = mButtonElements(index)
	Dim tmpBadge As BANanoElement
	tmpBadge.Initialize("#" & tmpButton.Name & "badge")
	Return tmpBadge.GetText
End Sub

public Sub SetButtonBadge(index As Int, value As String)
	Dim tmpButton As BANanoElement = mButtonElements(index)
	Dim tmpBadge As BANanoElement	
	tmpBadge.Initialize("#" & tmpButton.Name & "badge")
	tmpBadge.SetText(value)
End Sub

public Sub GotoButton(index As Int)
	mButtonElements(mActiveButton).RemoveClass("sk-mobile-nav-item-active")
	mButtonContents(mActiveButton).RemoveClass("sk-mobile-content-active")
	mButtonElements(index).AddClass("sk-mobile-nav-item-active")
	mButtonContents(index).AddClass("sk-mobile-content-active")
	mActiveButton = index
End Sub

#Region Internal Events
public Sub HandleClick(event As BANanoEvent)
	If mEnabled Then
		Dim src As String = event.OtherField("srcElement").GetField("id").Result
		Dim j As Int = src.LastIndexOf("_")
		If j > 0 Then
			src = src.SubString(j+1)
			Dim CurrentTag As Int = BANano.parseInt(src)
			
			If mActiveButton = CurrentTag Then
				BANano.CallSub(mCallBack, mEventName & "_click", Array(mActiveButton))
				Return
			End If
			
			mButtonElements(mActiveButton).RemoveClass("sk-mobile-nav-item-active")
			mButtonContents(mActiveButton).RemoveClass("sk-mobile-content-active")
			
			mButtonElements(CurrentTag).AddClass("sk-mobile-nav-item-active")
			mButtonContents(CurrentTag).AddClass("sk-mobile-content-active")
			mActiveButton = CurrentTag
		End If
		
		BANano.CallSub(mCallBack, mEventName & "_click", Array(mActiveButton))
	End If
End Sub
#End Region



