﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8
@EndOfDesignText@
'Custom BANano View class

'Uncomment the events you want to show to the user and implement the HandleEvents in DesignerCreateView 
'#Event: Focus (event As BANanoEvent)
'#Event: Blur (event As BANanoEvent)
'#Event: Resize (event As BANanoEvent)
'#Event: Scroll (event As BANanoEvent)
'#Event: Keydown (event As BANanoEvent)
'#Event: KeyPress (event As BANanoEvent)
'#Event: KeyUp (event As BANanoEvent)
#Event: CancelClick (event As BANanoEvent)
#Event: OKClick (event As BANanoEvent)
'#Event: ContextMenu (event As BANanoEvent)
'#Event: Dblclick (event As BANanoEvent)
'#Event: MouseDown (event As BANanoEvent)
'#Event: MouseEnter (event As BANanoEvent)
'#Event: MouseLeave (event As BANanoEvent)
'#Event: MouseMove (event As BANanoEvent)
'#Event: MouseOver (event As BANanoEvent)
'#Event: MouseOut (event As BANanoEvent)
'#Event: MouseUp (event As BANanoEvent)
'#Event: Wheel (event As BANanoEvent)
'#Event: Drag (event As BANanoEvent)
'#Event: DragEnd (event As BANanoEvent)
'#Event: DragEnter (event As BANanoEvent)
'#Event: DragStart (event As BANanoEvent)
'#Event: DragLeave (event As BANanoEvent)
'#Event: DragOver (event As BANanoEvent)
'#Event: Drop (event As BANanoEvent)
'#Event: TouchCancel (event As BANanoEvent)
'#Event: TouchEnd (event As BANanoEvent)
'#Event: TouchEnter (event As BANanoEvent)
'#Event: TouchLeave (event As BANanoEvent)
'#Event: TouchMove (event As BANanoEvent)
'#Event: TouchStart (event As BANanoEvent)
'#Event: Change (event As BANanoEvent)

' Properties that will be show in the ABStract Designer.  They will be passed in the props map in DesignerCreateView (Case Sensitive!)
#DesignerProperty: Key: Classes, DisplayName: Classes, FieldType: String, DefaultValue: , Description: Classes added to the HTML tag.
#DesignerProperty: Key: Style, DisplayName: Style, FieldType: String, DefaultValue: , Description: Styles added to the HTML tag. Must be a json String.

#DesignerProperty: Key: CancelText, DisplayName: Cancel text, FieldType: String, DefaultValue: Cancel, Description: Leave empty to not display it.
#DesignerProperty: Key: CancelFlavor, DisplayName: Cancel button Flavor, FieldType: String, DefaultValue: plain, List: plain|button-primary, Description: Cancel Button flavor.
#DesignerProperty: Key: OKText, DisplayName: Ok text, FieldType: String, DefaultValue: OK, Description: Leave empty To Not display it.
#DesignerProperty: Key: OKFlavor, DisplayName: OK button Flavor, FieldType: String, DefaultValue: button-primary, List: plain|button-primary, Description: OK Button flavor.
#DesignerProperty: Key: HaxClose, DisplayName: Has Close, FieldType: Boolean, DefaultValue: True, Description: Has a close X.
Sub Class_Globals
	Private BANano As BANano 'ignore
	Private S As SKShared
	Private mName As String 'ignore
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mTarget As BANanoElement 'ignore
	Private mElement As BANanoElement 'ignore
	Private mElementWrap As BANanoElement 'ignore
		
	Private mClasses As String = ""
	Private mStyle As String = ""
	
	Private mCancel As String = ""
	Private mOK As String = ""
	Private mHasClose As Boolean = True
	Private mOKFlavor As String = "button-primary"
	Private mCancelFlavor As String = "plain"
End Sub

Public Sub Initialize (CallBack As Object, Name As String, EventName As String)
	mName = Name.ToLowerCase
	mEventName = EventName.ToLowerCase
	mCallBack = CallBack
	S.Initialize(Me)
End Sub

' returns the BANanoElement
public Sub getElement() As BANanoElement
	Return mElement
End Sub

' returns the tag id
public Sub getID() As String
	Return mName
End Sub

' this is the place where you create the view in html and run initialize javascript
Public Sub DesignerCreateView (Target As BANanoElement, Props As Map)
	mTarget = Target

	If Props <> Null Then
		' set common properties
		S.SetProps(Props)
		' set component specific properties
		mCancel = Props.Get("CancelText")
		mOK = Props.Get("OKText")
		mHasClose = Props.Get("HasClose")
		mCancelFlavor = Props.Get("CancelFlavor")
		mOKFlavor = Props.Get("OKFlavor")
	End If
	
	If mCancelFlavor = "plain" Then
		mCancelFlavor = ""
	End If
	If mOKFlavor = "plain" Then
		mOKFlavor = ""
	End If
	
	Dim CloseX As String
	If mHasClose Then
		CloseX = $"<div class="modal-close-icon"><a href="javascript:void(0)" class="close-modal"><i class="fa fa-times" aria-hidden="true"></i></a></div>"$
	End If
	
	Dim Divider As String 
	Dim DividerEnd As String
	If mOK <> "" Or mCancel <> "" Then
		Divider = $"<hr class="modal-buttons-seperator"><div class="modal-buttons">"$
		DividerEnd = $"</div>"$
	End If
	
	Dim OKButton As String
	Dim CancelButton As String
	If mOK <> "" Then
		OKButton = $"<button id="${mName}ok" class="button ${mOKFlavor} close-modal">${mOK}</button>"$
	End If
	If mCancel <> "" Then
		CancelButton = $"<button id="${mName}cancel" class="button ${mCancelFlavor} close-modal">${mCancel}</button>"$
	End If
	
	' if you start a SmartString with [BANCLEAN] then BANano will remove all enters, tabs, etc while Transpiling
	mElement = mTarget.Append($"[BANCLEAN]
	<div id="${mName}wrap" class="modal ${mClasses} style=${mStyle}">
  		<div id="${mName}inner" class="modal-inner">
    		<div id="${mName}content" class="modal-content">
      			${CloseX}
      			<div id="${mName}" class="modal-content-inner"></div>
      			${Divider}      			
        		${CancelButton}
        		${OKButton}
      			${DividerEnd}
    		</div>
  		</div>
	</div>"$).Get("#" & mName)
	
	mElementWrap.Initialize("#" & mName & "wrap")
	If mOK <> "" Then
		Dim mOKElement As BANanoElement
		mOKElement.Initialize("#" & mName & "ok")
		mOKElement.Off("click").On("click", Me, "HandleClick")
	End If
	If mCancel <> "" Then
		Dim mCancelElement As BANanoElement
		mCancelElement.Initialize("#" & mName & "cancel")
		mCancelElement.Off("click").On("click", Me, "HandleClick")
	End If
	
	Dim tmpInner As BANanoElement
	tmpInner.Initialize("#" & mName & "inner")
	tmpInner.Off("click").On("click", Me, "HandleClick")
	
	Dim tmpContent As BANanoElement
	tmpContent.Initialize("#" & mName & "content")
	tmpContent.Off("click").On("click", Me, "HandleClick")
End Sub

public Sub AddToParent(targetID As String)
	mTarget = BANano.GetElement("#" & targetID.ToLowerCase)
	DesignerCreateView(mTarget, Null)
End Sub

public Sub Remove()
	mElementWrap.Remove
	BANano.SetMeToNull
End Sub

#Region common shared properties and methods
public Sub Trigger(event As String, params() As String)
	S.Trigger(mElementWrap, event, params)
End Sub

public Sub setClasses(Classes As String)
	S.SetClasses(mElementWrap, Classes)
End Sub

public Sub getClasses() As String
	Return S.GetClasses
End Sub

' must be a json string
' e.g. $"{ "width": "200px", "height": "200px", "background": "green", "border-radius": "5px" }"$
public Sub setStyle(Style As String)
	S.SetStyle(mElementWrap,Style)
End Sub

public Sub getStyle() As String
	Return S.GetStyle
End Sub
#End Region

public Sub GetContents As BANanoElement
	Return mElement
End Sub

public Sub Open()
	mElementWrap.AddClass("modal-open")
End Sub

public Sub Close()
	mElementWrap.RemoveClass("modal-open")
End Sub

#Region Internal Events
public Sub HandleClick(event As BANanoEvent)
	Dim from As String = event.OtherField("srcElement").GetField("id").Result
	Select Case from
		Case mName & "ok"
			Close
			event.PreventDefault
			event.StopPropagation
			BANano.CallSub(mCallBack, mEventName & "_okclick", Array(event))
		Case mName & "cancel"
			Close
			event.PreventDefault
			event.StopPropagation
			BANano.CallSub(mCallBack, mEventName & "_cancelclick", Array(event))
		Case mName & "inner"
			Close
			event.PreventDefault
			event.StopPropagation
			BANano.CallSub(mCallBack, mEventName & "_cancelclick", Array(event))
		Case mName & "content"
			event.PreventDefault
			event.StopPropagation
	End Select	
End Sub
#End Region



