﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7
@EndOfDesignText@
'Custom BANano View class

'Uncomment the events you want to show to the user and implement the HandleEvents in DesignerCreateView 
'#Event: Focus (event As BANanoEvent)
'#Event: Blur (event As BANanoEvent)
'#Event: Resize (event As BANanoEvent)
'#Event: Scroll (event As BANanoEvent)
'#Event: Keydown (event As BANanoEvent)
'#Event: KeyPress (event As BANanoEvent)
'#Event: KeyUp (event As BANanoEvent)
#Event: Click (event As BANanoEvent, menu As String)
'#Event: ContextMenu (event As BANanoEvent)
'#Event: Dblclick (event As BANanoEvent)
'#Event: MouseDown (event As BANanoEvent)
'#Event: MouseEnter (event As BANanoEvent)
'#Event: MouseLeave (event As BANanoEvent)
'#Event: MouseMove (event As BANanoEvent)
'#Event: MouseOver (event As BANanoEvent)
'#Event: MouseOut (event As BANanoEvent)
'#Event: MouseUp (event As BANanoEvent)
'#Event: Wheel (event As BANanoEvent)
'#Event: Drag (event As BANanoEvent)
'#Event: DragEnd (event As BANanoEvent)
'#Event: DragEnter (event As BANanoEvent)
'#Event: DragStart (event As BANanoEvent)
'#Event: DragLeave (event As BANanoEvent)
'#Event: DragOver (event As BANanoEvent)
'#Event: Drop (event As BANanoEvent)
'#Event: TouchCancel (event As BANanoEvent)
'#Event: TouchEnd (event As BANanoEvent)
'#Event: TouchEnter (event As BANanoEvent)
'#Event: TouchLeave (event As BANanoEvent)
'#Event: TouchMove (event As BANanoEvent)
'#Event: TouchStart (event As BANanoEvent)
'#Event: Change (event As BANanoEvent)

' Properties that will be show in the ABStract Designer.  They will be passed in the props map in DesignerCreateView (Case Sensitive!)
#DesignerProperty: Key: Classes, DisplayName: Classes, FieldType: String, DefaultValue: , Description: Classes added to the HTML tag.
#DesignerProperty: Key: Style, DisplayName: Style, FieldType: String, DefaultValue: , Description: Styles added to the HTML tag. Must be a json String.
#DesignerProperty: Key: MarginLeft, DisplayName: Margin Left, FieldType: String, DefaultValue: , Description: Margin Left
#DesignerProperty: Key: MarginRight, DisplayName: Margin Right, FieldType: String, DefaultValue: , Description: Margin Right
#DesignerProperty: Key: MarginTop, DisplayName: Margin Top, FieldType: String, DefaultValue: , Description: Margin Top
#DesignerProperty: Key: MarginBottom, DisplayName: Margin Bottom, FieldType: String, DefaultValue: , Description: Margin Bottom
#DesignerProperty: Key: PaddingLeft, DisplayName: Padding Left, FieldType: String, DefaultValue: , Description: Padding Left
#DesignerProperty: Key: PaddingRight, DisplayName: Padding Right, FieldType: String, DefaultValue: , Description: Padding Right
#DesignerProperty: Key: PaddingTop, DisplayName: Padding Top, FieldType: String, DefaultValue: , Description: Padding Top
#DesignerProperty: Key: PaddingBottom, DisplayName: Padding Bottom, FieldType: String, DefaultValue: , Description: Padding Bottom
#DesignerProperty: Key: Visible, DisplayName: Visible, FieldType: Boolean, DefaultValue: True, Description: If visible.
Sub Class_Globals
    Private BANano As BANano 'ignore
	Private S As SKShared
	Private mName As String 'ignore
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mTarget As BANanoElement 'ignore
	Private mElement As BANanoElement 'ignore
	Private mOverlay As BANanoElement 'ignore
	
	Private mClasses As String = ""
	Private mStyle As String = ""
	Public MarginLeft As String = ""
	Public MarginRight As String = ""
	Public MarginTop As String = ""
	Public MarginBottom As String = ""
	Public PaddingLeft As String = ""
	Public PaddingRight As String = ""
	Public PaddingTop As String = ""
	Public PaddingBottom As String = ""
	Private mVisible As Boolean = True
		
End Sub

Public Sub Initialize (CallBack As Object, Name As String, EventName As String)
	mName = Name.ToLowerCase
	mEventName = EventName.ToLowerCase
	mCallBack = CallBack
	S.Initialize(Me)
End Sub

' returns the BANanoElement
public Sub getElement() As BANanoElement
	Return mElement
End Sub

' returns the tag id
public Sub getID() As String
	Return mName
End Sub

' this is the place where you create the view in html and run initialize javascript
Public Sub DesignerCreateView (Target As BANanoElement, Props As Map)
	mTarget = Target

	If Props <> Null Then
		' set common properties
		S.SetProps(Props)
		' set component specific properties
	End If
	
	Dim exStyle As String = BuildExStyle
	
	mElement = mTarget.Append($"<div id="${mName}" class="navBar ${mClasses}" style="${exStyle}${mStyle}"><div id="${mName}drawer" class="icon">&#9776;</div></div><div id="overlay"></div>"$).Get("#" & mName)
	setVisible(mVisible)
	Dim mDrawer As BANanoElement = mTarget.Get("#" & mName & "drawer")
	mDrawer.HandleEvents("click", Me, "toggledrawermenu")
	
	mOverlay = mTarget.Get("#overlay")
	mOverlay.HandleEvents("click", Me, "closedrawermenu")
		
	'' defining events is very simple. Note that it has to be run AFTER adding it to the HTML DOM! eventName must be lowercase!
	'mElement.HandleEvents("click", mCallBack, mEventName & "_click")
	'mElement.HandleEvents("mouseenter", Me, "mouseenter")
End Sub

public Sub AddToParent(targetID As String)
	mTarget = BANano.GetElement("#" & targetID.ToLowerCase)
	DesignerCreateView(mTarget, Null)
End Sub

public Sub Remove()
	mElement.Remove
	mOverlay.Remove
	BANano.SetMeToNull
End Sub

#Region common shared properties and methods
public Sub Trigger(event As String, params() As String)
	S.Trigger(mElement, event, params)
End Sub

public Sub BuildExStyle() As String
	Return S.BuildExStyle
End Sub

public Sub setClasses(Classes As String)
	S.SetClasses(mElement, Classes)
End Sub

public Sub getClasses() As String
	Return S.GetClasses
End Sub

' must be a json string
' e.g. $"{ "width": "200px", "height": "200px", "background": "green", "border-radius": "5px" }"$
public Sub setStyle(Style As String)
	S.SetStyle(mElement,Style)
End Sub

public Sub getStyle() As String
	Return S.GetStyle
End Sub

public Sub setVisible(Visible As Boolean)
	S.SetVisible(mElement, Visible)
End Sub

public Sub getVisible() As Boolean
	Return S.GetVisible(mElement)
End Sub
#End Region

' do not use spaces in the name, as it will be a HTML id
public Sub AddMenu(Name As String, Title As String)
	Dim menu As BANanoElement = mElement.Prepend($"<div id="${Name.ToLowerCase}">${BANano.SF(Title)}</div>"$).Get("#" & Name.ToLowerCase)
	menu.HandleEvents("click", Me, "handleclick")
End Sub

public Sub SetMenu(Name As String, Title As String)
	Dim menu As BANanoElement = BANano.getElement("#" & Name.ToLowerCase)
	menu.SetText(BANano.SF(Title))	
End Sub

public Sub AddImage(Name As String, src As String, Style As String, prep As Boolean)	
	Dim menu As BANanoElement 
	If prep Then
		menu = mElement.Prepend($"<img id="${Name.ToLowerCase}" src="${src}" style="${Style}"></img>"$).Get("#" & Name.ToLowerCase)
	Else
		menu = mElement.append($"<img id="${Name.ToLowerCase}" src="${src}" style="${Style}"></img>"$).Get("#" & Name.ToLowerCase)
	End If
	menu.HandleEvents("click", Me, "handleclick")
End Sub

public Sub ToggleDrawerMenu()	
	If mElement.HasClass("responsive") Then
		CloseDrawerMenu
	Else
		OpenDrawerMenu
	End If
End Sub

public Sub CloseDrawerMenu()
	mElement.RemoveClass("responsive")
	mOverlay.RemoveClass("visible")
End Sub

public Sub OpenDrawerMenu()
	mOverlay.AddClass("visible")
	mElement.AddClass("responsive")
End Sub

#Region Internal Events
public Sub HandleClick(event As BANanoEvent)
	BANano.CallSub(mCallBack, mEventName & "_click", Array(event, event.ID))
End Sub
#End Region

