﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8
@EndOfDesignText@
'Custom BANano View class

'Uncomment the events you want to show to the user and implement the HandleEvents in DesignerCreateView 
'#Event: Focus (event As BANanoEvent)
'#Event: Blur (event As BANanoEvent)
'#Event: Resize (event As BANanoEvent)
'#Event: Scroll (event As BANanoEvent)
'#Event: Keydown (event As BANanoEvent)
'#Event: KeyUp (event As BANanoEvent)
'#Event: Click (event As BANanoEvent)
'#Event: ContextMenu (event As BANanoEvent)
'#Event: Dblclick (event As BANanoEvent)
'#Event: MouseDown (event As BANanoEvent)
'#Event: MouseEnter (event As BANanoEvent)
'#Event: MouseLeave (event As BANanoEvent)
'#Event: MouseMove (event As BANanoEvent)
'#Event: MouseOver (event As BANanoEvent)
'#Event: MouseOut (event As BANanoEvent)
'#Event: MouseUp (event As BANanoEvent)
'#Event: Wheel (event As BANanoEvent)
'#Event: Drag (event As BANanoEvent)
'#Event: DragEnd (event As BANanoEvent)
'#Event: DragEnter (event As BANanoEvent)
'#Event: DragStart (event As BANanoEvent)
'#Event: DragLeave (event As BANanoEvent)
'#Event: DragOver (event As BANanoEvent)
'#Event: Drop (event As BANanoEvent)
'#Event: TouchCancel (event As BANanoEvent)
'#Event: TouchEnd (event As BANanoEvent)
'#Event: TouchEnter (event As BANanoEvent)
'#Event: TouchLeave (event As BANanoEvent)
'#Event: TouchMove (event As BANanoEvent)
'#Event: TouchStart (event As BANanoEvent)
'#Event: Change (event As BANanoEvent)
#Event: LoadContent (startIndex as int, endIndex as int)

' Properties that will be show in the ABStract Designer.  They will be passed in the props map in DesignerCreateView (Case Sensitive!)
#DesignerProperty: Key: Classes, DisplayName: Classes, FieldType: String, DefaultValue: , Description: Classes added to the HTML tag.
#DesignerProperty: Key: Style, DisplayName: Style, FieldType: String, DefaultValue: , Description: Styles added to the HTML tag. Must be a json String.
#DesignerProperty: Key: MarginLeft, DisplayName: Margin Left, FieldType: String, DefaultValue: , Description: Margin Left
#DesignerProperty: Key: MarginRight, DisplayName: Margin Right, FieldType: String, DefaultValue: , Description: Margin Right
#DesignerProperty: Key: MarginTop, DisplayName: Margin Top, FieldType: String, DefaultValue: , Description: Margin Top
#DesignerProperty: Key: MarginBottom, DisplayName: Margin Bottom, FieldType: String, DefaultValue: , Description: Margin Bottom
#DesignerProperty: Key: PaddingLeft, DisplayName: Padding Left, FieldType: String, DefaultValue: , Description: Padding Left
#DesignerProperty: Key: PaddingRight, DisplayName: Padding Right, FieldType: String, DefaultValue: , Description: Padding Right
#DesignerProperty: Key: PaddingTop, DisplayName: Padding Top, FieldType: String, DefaultValue: , Description: Padding Top
#DesignerProperty: Key: PaddingBottom, DisplayName: Padding Bottom, FieldType: String, DefaultValue: , Description: Padding Bottom
#DesignerProperty: Key: Enabled, DisplayName: Enabled, FieldType: Boolean, DefaultValue: True, Description: If enabled.
#DesignerProperty: Key: Visible, DisplayName: Visible, FieldType: Boolean, DefaultValue: True, Description: If visible.

#DesignerProperty: Key: Bordered, DisplayName: Bordered, FieldType: Boolean, DefaultValue: True, Description: Borders around the buttons.
#DesignerProperty: Key: Prev, DisplayName: Previous text, FieldType: String, DefaultValue: prev, Description: Text shown on the previous button.
#DesignerProperty: Key: Next, DisplayName: Next text, FieldType: String, DefaultValue: next, Description: Text shown on the next button.
#DesignerProperty: Key: Align, DisplayName: Align, FieldType: String, DefaultValue: left, list: left|center|right, Description: Alignment of the component.
Sub Class_Globals
	Private BANano As BANano 'ignore
	Private S As SKShared
	Private mName As String 'ignore
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mTarget As BANanoElement 'ignore
	Private mElement As BANanoElement 'ignore
		
	Private mClasses As String = ""
	Private mStyle As String = ""
	Public MarginLeft As String = ""
	Public MarginRight As String = ""
	Public MarginTop As String = ""
	Public MarginBottom As String = ""
	Public PaddingLeft As String = ""
	Public PaddingRight As String = ""
	Public PaddingTop As String = ""
	Public PaddingBottom As String = ""
	Private mVisible As Boolean = True
	Private mEnabled As Boolean = True
	
	Private mBordered As Boolean = True
	
	Private mTotalItems As Int
	Private mPageSize As Int
	Private mMaxPages As Int
	Private mCurrentPage As Int
	Private mTotalPages As Int
	
	Private mPrev As String = "prev"
	Private mNext As String = "next"
	
	Private mStartIndex As Int
	Private mEndIndex As Int
	Private mAlign As String = "left"
End Sub

Public Sub Initialize (CallBack As Object, Name As String, EventName As String)
	mName = Name.ToLowerCase
	mEventName = EventName.ToLowerCase
	mCallBack = CallBack
	S.Initialize(Me)
End Sub

' returns the BANanoElement
public Sub getElement() As BANanoElement
	Return mElement
End Sub

' returns the tag id
public Sub getID() As String
	Return mName
End Sub

' this is the place where you create the view in html and run initialize javascript.  Must be Public!
Public Sub DesignerCreateView (Target As BANanoElement, Props As Map)
	mTarget = Target

	If Props <> Null Then
		' set common properties
		S.SetProps(Props)
		' set component specific properties
		mBordered = Props.Get("Bordered")
		mPrev = Props.Get("Prev")
		mNext = Props.Get("Next")
		mAlign = Props.GetDefault("Align", mAlign)
	End If
	
	Dim exStyle As String = BuildExStyle
	
	Dim tmpBordered As String
	If mBordered Then
		tmpBordered = "sk-pagination-bordered"
	End If
	
	Dim tmpAlign As String
	Select Case mAlign
		Case "left"
		Case "right"
			tmpAlign = "sk-pag-right"
		Case "center"
			tmpAlign = "sk-pag-center"
	End Select
	
	mElement = mTarget.Append($"<div id="${mName}" class="sk-pagination ${tmpAlign} ${tmpBordered} ${mClasses}" style="${exStyle}${mStyle}"></div>"$).Get("#" & mName)
	setEnabled(mEnabled)
	setVisible(mVisible)
		
	'' defining events is very simple. Note that it has to be run AFTER adding it to the HTML DOM! eventName must be lowercase!	
End Sub

public Sub Build(totalItems As Int, pageSize As Int, maxPages As Int)
	mTotalItems = totalItems
	mPageSize = pageSize
	mMaxPages = maxPages
	mCurrentPage = 1
	mTotalPages = Ceil(mTotalItems/mPageSize)
	CalcPages
End Sub

private Sub CalcPages()
	Dim StartPage, EndPage As Int
	If mCurrentPage < 1 Then
		mCurrentPage = 1
	Else
		If mCurrentPage > mTotalPages Then
			mCurrentPage = mTotalPages
		End If
	End If
	If mTotalPages <= mMaxPages Then
		StartPage = 1
		EndPage = mTotalPages
	Else
		Dim MaxPagesBeforeCurrentPage As Int = Floor(mMaxPages/2)
		Dim MaxPagesAfterCurrentPage As Int = Ceil(mMaxPages/2) - 1
		If mCurrentPage <= MaxPagesBeforeCurrentPage Then
			StartPage = 1
			EndPage = mMaxPages
		Else
			If mCurrentPage + MaxPagesAfterCurrentPage >= mTotalPages Then
				StartPage = mTotalPages - mMaxPages + 1
				EndPage = mTotalPages
			Else
				StartPage = mCurrentPage - MaxPagesBeforeCurrentPage
				EndPage = mCurrentPage + MaxPagesAfterCurrentPage	
			End If
		End If		
	End If	
		
	mStartIndex = (mCurrentPage - 1) * mPageSize
	mEndIndex = Min(mStartIndex + mPageSize - 1, mTotalItems - 1)
	
	Dim btnClicks As BANanoElement
	' get the old ones (if any)
	btnClicks.Initialize(".sk-pagination-item")
	btnClicks.off("click")
	Dim Buttons As String
	If mCurrentPage = 1 Then
		Buttons = Buttons & $"<div class="sk-pagination-item short" data-pag="prev"><a disabled href="#">${mPrev}</a></div>"$
	Else
		Buttons = Buttons & $"<div class="sk-pagination-item short" data-pag="prev"><a href="#">${mPrev}</a></div>"$
	End If		
	For i = StartPage To EndPage
		If i = mCurrentPage Then
			Buttons = Buttons & $"<div class="sk-pagination-item short selected" data-pag="${i}"><a href="#">${i}</a></div>"$
		Else
			Buttons = Buttons & $"<div class="sk-pagination-item short" data-pag="${i}"><a href="#">${i}</a></div>"$
		End If		
	Next
	If mCurrentPage = mTotalPages Then
		Buttons = Buttons & $"<div class="sk-pagination-item short" data-pag="next"><a disabled href="#">${mNext}</a></div>"$
	Else
		Buttons = Buttons & $"<div class="sk-pagination-item short" data-pag="next"><a href="#">${mNext}</a></div>"$
	End If
	mElement.SetHTML(Buttons)
	' get the new ones
	btnClicks.Initialize(".sk-pagination-item")
	btnClicks.on("click",Me,"HandleClicks")
End Sub

public Sub AddToParent(targetID As String)
	mTarget = BANano.GetElement("#" & targetID.ToLowerCase)
	DesignerCreateView(mTarget, Null)
End Sub

public Sub Remove()
	mElement.Remove
	BANano.SetMeToNull
End Sub

#Region common shared properties and methods
public Sub Trigger(event As String, params() As String)
	S.Trigger(mElement, event, params)
End Sub

public Sub BuildExStyle() As String
	Return S.BuildExStyle
End Sub

public Sub setClasses(Classes As String)
	S.SetClasses(mElement, Classes)
End Sub

public Sub getClasses() As String
	Return S.GetClasses
End Sub

' must be a json string
' e.g. $"{ "width": "200px", "height": "200px", "background": "green", "border-radius": "5px" }"$
public Sub setStyle(Style As String)
	S.SetStyle(mElement,Style)
End Sub

public Sub getStyle() As String
	Return S.GetStyle
End Sub

public Sub setVisible(Visible As Boolean)
	S.SetVisible(mElement, Visible)
End Sub

public Sub getVisible() As Boolean
	Return S.GetVisible(mElement)
End Sub

public Sub setEnabled(Enabled As Boolean)
	S.SetEnabled(mElement, Enabled)
End Sub

public Sub getEnabled() As Boolean
	Return S.GetEnabled(mElement)
End Sub
#End Region

#Region Internal Events
private Sub HandleClicks(event As BANanoEvent) 'ignore
	event.PreventDefault
	event.StopPropagation
	If mEnabled Then
		Dim src As String = event.OtherField("srcElement").Result
		Dim tmpBtn As BANanoElement
		tmpBtn.Initialize(src)
		Dim btnType As String = tmpBtn.GetAttr("data-pag")
		Select Case btnType
			Case "prev"
				mCurrentPage = mCurrentPage - 1				
			Case "next"
				mCurrentPage = mCurrentPage + 1								
			Case Else
				Dim tmpTypeInt As Int = BANano.parseInt(btnType)
				If mCurrentPage <> tmpTypeInt Then
					mCurrentPage = tmpTypeInt
				Else
					Return	
				End If	
		End Select
		
		CalcPages
		BANano.CallSub(mCallBack, mEventName & "_loadcontent", Array(mStartIndex, mEndIndex))
	End If
End Sub
#End Region

