﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.1
@EndOfDesignText@
Sub Class_Globals
	Private BANano As BANano 'ignore
	Private mSelf As Object	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(self As Object)
	mSelf = self	
End Sub

public Sub Trigger(mElement As BANanoElement, event As String, params() As String)	
	If mElement <> Null Then
		mElement.Trigger(event, params)
	End If
End Sub

public Sub SetProps(props As Map)
	BANano.SetP(mSelf, "mClasses", props.Get("Classes"))
	BANano.SetP(mSelf, "mStyle", props.Get("Style"))
	BANano.SetP(mSelf, "MarginLeft", props.Get("MarginLeft"))
	BANano.SetP(mSelf, "MarginRight", props.Get("MarginRight"))
	BANano.SetP(mSelf, "MarginTop", props.Get("MarginTop"))
	BANano.SetP(mSelf, "MarginBottom", props.Get("MarginBottom"))
	BANano.SetP(mSelf, "PaddingLeft", props.Get("PaddingLeft"))
	BANano.SetP(mSelf, "PaddingRight", props.Get("PaddingRight"))
	BANano.SetP(mSelf, "PaddingTop", props.Get("PaddingTop"))
	BANano.SetP(mSelf, "PaddingBottom", props.Get("PaddingBottom"))			
	BANano.SetP(mSelf, "mVisible", props.Get("Visible"))
	BANano.SetP(mSelf, "mEnabled", props.Get("Enabled"))
End Sub

public Sub BuildExStyle() As String
	Dim sb As StringBuilder
	sb.Initialize
	If Not(BANano.GetP(mSelf, "MarginLeft") = "" Or BANano.GetP(mSelf, "MarginLeft") = BANano.UNDEFINED) Then sb.Append("margin-left: " & BANano.GetP(mSelf, "MarginLeft")).Append(";")
	If Not(BANano.GetP(mSelf, "MarginRight") = "" Or BANano.GetP(mSelf, "MarginRight") = BANano.UNDEFINED) Then sb.Append("margin-right: " & BANano.GetP(mSelf, "MarginRight")).Append(";")
	If Not(BANano.GetP(mSelf, "MarginTop") = "" Or BANano.GetP(mSelf, "MarginTop") = BANano.UNDEFINED) Then sb.Append("margin-top: " & BANano.GetP(mSelf, "MarginTop")).Append(";")
	If Not(BANano.GetP(mSelf, "MarginBottom") = "" Or BANano.GetP(mSelf, "MarginBottom") = BANano.UNDEFINED) Then sb.Append("margin-bottom: " & BANano.GetP(mSelf, "MarginBottom")).Append(";")
	If Not(BANano.GetP(mSelf, "PaddingLeft") = "" Or BANano.GetP(mSelf, "PaddingLeft") = BANano.UNDEFINED) Then sb.Append("padding-left: " & BANano.GetP(mSelf, "PaddingLeft")).Append(";")
	If Not(BANano.GetP(mSelf, "PaddingRight") = "" Or BANano.GetP(mSelf, "PaddingRight") = BANano.UNDEFINED) Then sb.Append("padding-right: " & BANano.GetP(mSelf, "PaddingRight")).Append(";")
	If Not(BANano.GetP(mSelf, "PaddingTop") = "" Or BANano.GetP(mSelf, "PaddingTop") = BANano.UNDEFINED) Then sb.Append("padding-top: " & BANano.GetP(mSelf, "PaddingTop")).Append(";")
	If Not(BANano.GetP(mSelf, "PaddingBottom") = "" Or BANano.GetP(mSelf, "PaddingBottom") = BANano.UNDEFINED) Then sb.Append("padding-bottom: " & BANano.GetP(mSelf, "PaddingBottom")).Append(";")
	Return sb.ToString
End Sub

#Region Property Getters and Setters
public Sub SetClasses(mElement As BANanoElement, Classes As String)
	If mElement <> Null Then
		mElement.AddClass(Classes)
	End If
	BANano.SetP(mSelf, "mClasses", Classes)
End Sub

public Sub GetClasses() As String
	Return BANano.GetP(mSelf, "mClasses")
End Sub

' must be a json string
' e.g. $"{ "width": "200px", "height": "200px", "background": "green", "border-radius": "5px" }"$
public Sub SetStyle(mElement As BANanoElement, Style As String)
	If mElement <> Null Then
		mElement.SetStyle(Style)
	End If
	BANano.SetP(mSelf, "mStyle", Style)
End Sub

public Sub GetStyle() As String
	Return BANano.GetP(mSelf, "mStyle")
End Sub

public Sub SetVisible(mElement As BANanoElement, Visible As Boolean)
	If mElement <> Null Then
		If Visible Then
			mElement.RemoveClass("u-hide")
		Else
			mElement.AddClass("u-hide")
		End If
	End If
	BANano.SetP(mSelf, "mVisible", Visible)
End Sub

public Sub GetVisible(mElement As BANanoElement) As Boolean
	Dim mVisible As Boolean = Not(mElement.HasClass("u-hide"))
	BANano.SetP(mSelf, "mVisible", mVisible)
	Return mVisible
End Sub

public Sub SetEnabled(mElement As BANanoElement, Enabled As Boolean)
	If mElement <> Null Then
		If Enabled Then
			mElement.RemoveAttr("disabled")
		Else
			mElement.SetAttr("disabled", True)
		End If
	End If
	BANano.SetP(mSelf, "mEnabled", Enabled)
End Sub

public Sub GetEnabled(mElement As BANanoElement) As Boolean
	Dim mEnabled As Boolean = not(mElement.hasAttr("disabled"))
	BANano.SetP(mSelf, "mEnabled", mEnabled)
	Return mEnabled
End Sub
