﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8
@EndOfDesignText@
'Custom BANano View class

'Uncomment the events you want to show to the user and implement the HandleEvents in DesignerCreateView 
'#Event: Focus (event As BANanoEvent)
'#Event: Blur (event As BANanoEvent)
'#Event: Resize (event As BANanoEvent)
'#Event: Scroll (event As BANanoEvent)
'#Event: Keydown (event As BANanoEvent)
'#Event: KeyPress (event As BANanoEvent)
'#Event: KeyUp (event As BANanoEvent)
'#Event: Click (event As BANanoEvent)
'#Event: ContextMenu (event As BANanoEvent)
'#Event: Dblclick (event As BANanoEvent)
'#Event: MouseDown (event As BANanoEvent)
'#Event: MouseEnter (event As BANanoEvent)
'#Event: MouseLeave (event As BANanoEvent)
'#Event: MouseMove (event As BANanoEvent)
'#Event: MouseOver (event As BANanoEvent)
'#Event: MouseOut (event As BANanoEvent)
'#Event: MouseUp (event As BANanoEvent)
'#Event: Wheel (event As BANanoEvent)
'#Event: Drag (event As BANanoEvent)
'#Event: DragEnd (event As BANanoEvent)
'#Event: DragEnter (event As BANanoEvent)
'#Event: DragStart (event As BANanoEvent)
'#Event: DragLeave (event As BANanoEvent)
'#Event: DragOver (event As BANanoEvent)
'#Event: Drop (event As BANanoEvent)
'#Event: TouchCancel (event As BANanoEvent)
'#Event: TouchEnd (event As BANanoEvent)
'#Event: TouchEnter (event As BANanoEvent)
'#Event: TouchLeave (event As BANanoEvent)
'#Event: TouchMove (event As BANanoEvent)
'#Event: TouchStart (event As BANanoEvent)
'#Event: Change (event As BANanoEvent)

' Properties that will be show in the ABStract Designer.  They will be passed in the props map in DesignerCreateView (Case Sensitive!)
#DesignerProperty: Key: Classes, DisplayName: Classes, FieldType: String, DefaultValue: , Description: Classes added to the HTML tag.
#DesignerProperty: Key: Style, DisplayName: Style, FieldType: String, DefaultValue: , Description: Styles added to the HTML tag. Must be a json String.
#DesignerProperty: Key: Type, DisplayName: Type, FieldType: String, DefaultValue: left, List: left|right, Description: Type sidebar
Sub Class_Globals
	Private BANano As BANano 'ignore
	Private S As SKShared
	Private mName As String 'ignore
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mTarget As BANanoElement 'ignore
	Private mElement As BANanoElement 'ignore
	Private mElementOverlay As BANanoElement
	Private mBody As BANanoElement
		
	Private mClasses As String = ""
	Private mStyle As String = ""
	Private mType As String = "left"	
End Sub

Public Sub Initialize (CallBack As Object, Name As String, EventName As String)
	mName = Name.ToLowerCase
	mEventName = EventName.ToLowerCase
	mCallBack = CallBack
	S.Initialize(Me)
End Sub

' returns the BANanoElement
public Sub getElement() As BANanoElement
	Return mElement
End Sub

' returns the tag id
public Sub getID() As String
	Return mName
End Sub

' this is the place where you create the view in html and run initialize javascript
Public Sub DesignerCreateView (Target As BANanoElement, Props As Map)
	mTarget = Target

	If Props <> Null Then
		' set common properties
		S.SetProps(Props)
		' set component specific properties
		mType = Props.Get("Type")
	End If
	
	Dim LeftRight As String
	If mType = "left" Then
		LeftRight = "bansk-animate-left"
	Else
		LeftRight = "bansk-animate-right"
		mStyle = mStyle & ";right:0"
	End If	
	
	' if you start a SmartString with [BANCLEAN] then BANano will remove all enters, tabs, etc while Transpiling
	mElement = mTarget.Append($"[BANCLEAN]
		<div id="${mName}overlay" class="bansk-overlay u-hide"></div>
		<div class="bansk-sidebar u-hide ${LeftRight} ${mClasses}" style="${mStyle}" id="${mName}"></div>
	"$).Get("#" & mName)
	mElementOverlay.Initialize("#" & mName & "overlay")	
	mElementOverlay.On("click", Me, "close")
	
	mBody.Initialize("body")
End Sub

public Sub AddToParent(targetID As String)
	mTarget = BANano.GetElement("#" & targetID.ToLowerCase)
	DesignerCreateView(mTarget, Null)
End Sub

public Sub Remove()
	mElementOverlay.Remove
	mElement.Remove
	BANano.SetMeToNull
End Sub

public Sub Clear()
	mElement.Empty
End Sub

#Region common shared properties and methods
public Sub Trigger(event As String, params() As String)
	S.Trigger(mElement, event, params)
End Sub

public Sub setClasses(Classes As String)
	S.SetClasses(mElement, Classes)
End Sub

public Sub getClasses() As String
	Return S.GetClasses
End Sub

' must be a json string
' e.g. $"{ "width": "200px", "height": "200px", "background": "green", "border-radius": "5px" }"$
public Sub setStyle(Style As String)
	S.SetStyle(mElement,Style)
End Sub

public Sub getStyle() As String
	Return S.GetStyle
End Sub
#End Region

public Sub Open()
	mBody.AddClass("sk-noscroll")
	mElement.RemoveClass("u-hide")
	mElementOverlay.RemoveClass("u-hide")
End Sub

public Sub Close()
	mElement.AddClass("u-hide")
	mElementOverlay.AddClass("u-hide")
	mBody.RemoveClass("sk-noscroll")
End Sub

#Region Internal Events

#End Region



