﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.31
@EndOfDesignText@
'Custom BANano View class

'Uncomment the events you want to show to the user and implement the HandleEvents in DesignerCreateView 
'#Event: Focus (event As BANanoEvent)
'#Event: Blur (event As BANanoEvent)
'#Event: Resize (event As BANanoEvent)
'#Event: Scroll (event As BANanoEvent)
'#Event: Keydown (event As BANanoEvent)
'#Event: KeyPress (event As BANanoEvent)
'#Event: KeyUp (event As BANanoEvent)
'#Event: Click (event As BANanoEvent)
'#Event: ContextMenu (event As BANanoEvent)
'#Event: Dblclick (event As BANanoEvent)
'#Event: MouseDown (event As BANanoEvent)
'#Event: MouseEnter (event As BANanoEvent)
'#Event: MouseLeave (event As BANanoEvent)
'#Event: MouseMove (event As BANanoEvent)
'#Event: MouseOver (event As BANanoEvent)
'#Event: MouseOut (event As BANanoEvent)
'#Event: MouseUp (event As BANanoEvent)
'#Event: Wheel (event As BANanoEvent)
'#Event: Drag (event As BANanoEvent)
'#Event: DragEnd (event As BANanoEvent)
'#Event: DragEnter (event As BANanoEvent)
'#Event: DragStart (event As BANanoEvent)
'#Event: DragLeave (event As BANanoEvent)
'#Event: DragOver (event As BANanoEvent)
'#Event: Drop (event As BANanoEvent)
'#Event: TouchCancel (event As BANanoEvent)
'#Event: TouchEnd (event As BANanoEvent)
'#Event: TouchEnter (event As BANanoEvent)
'#Event: TouchLeave (event As BANanoEvent)
'#Event: TouchMove (event As BANanoEvent)
'#Event: TouchStart (event As BANanoEvent)
'#Event: Change (event As BANanoEvent)

' Properties that will be show in the ABStract Designer.  They will be passed in the props map in DesignerCreateView (Case Sensitive!)
#DesignerProperty: Key: Classes, DisplayName: Classes, FieldType: String, DefaultValue: , Description: Classes added to the HTML tag.
#DesignerProperty: Key: Style, DisplayName: Style, FieldType: String, DefaultValue: , Description: Styles added to the HTML tag. Must be a json String.
#DesignerProperty: Key: MarginLeft, DisplayName: Margin Left, FieldType: String, DefaultValue: , Description: Margin Left
#DesignerProperty: Key: MarginRight, DisplayName: Margin Right, FieldType: String, DefaultValue: , Description: Margin Right
#DesignerProperty: Key: MarginTop, DisplayName: Margin Top, FieldType: String, DefaultValue: , Description: Margin Top
#DesignerProperty: Key: MarginBottom, DisplayName: Margin Bottom, FieldType: String, DefaultValue: , Description: Margin Bottom
#DesignerProperty: Key: PaddingLeft, DisplayName: Padding Left, FieldType: String, DefaultValue: , Description: Padding Left
#DesignerProperty: Key: PaddingRight, DisplayName: Padding Right, FieldType: String, DefaultValue: , Description: Padding Right
#DesignerProperty: Key: PaddingTop, DisplayName: Padding Top, FieldType: String, DefaultValue: , Description: Padding Top
#DesignerProperty: Key: PaddingBottom, DisplayName: Padding Bottom, FieldType: String, DefaultValue: , Description: Padding Bottom
#DesignerProperty: Key: Width, DisplayName: Width, FieldType: Int, DefaultValue: 450, Description: Width of the pad
#DesignerProperty: Key: Height, DisplayName: Height, FieldType: Int, DefaultValue: 350, Description: Height of the pad
#DesignerProperty: Key: BackgroundColor, DisplayName: Background Color, FieldType: String, DefaultValue: white, Description: Background color
#DesignerProperty: Key: PenColor, DisplayName: Pen Color, FieldType: String, DefaultValue: black, Description: Pen color
Sub Class_Globals
    Private BANano As BANano 'ignore
	Private S As SKShared
	Private mName As String 'ignore
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mTarget As BANanoElement 'ignore
	Private mElement As BANanoElement 'ignore
	Private mSignaturePad As BANanoObject
	
	Private mClasses As String = ""
	Private mStyle As String = ""
	Public MarginLeft As String = ""
	Public MarginRight As String = ""
	Public MarginTop As String = ""
	Public MarginBottom As String = ""
	Public PaddingLeft As String = ""
	Public PaddingRight As String = ""
	Public PaddingTop As String = ""
	Public PaddingBottom As String = ""
	Private mWidth As Int = 450
	Private mHeight As Int = 350
	Private mBackgroundColor As String = "white"
	Private mPenColor As String = "Black"
End Sub

Public Sub Initialize (CallBack As Object, Name As String, EventName As String)
	mName = Name
	mEventName = EventName.ToLowerCase
	mCallBack = CallBack	
	S.Initialize(Me)
End Sub

' this is the place where you create the view in html and run initialize javascript
Public Sub DesignerCreateView (Target As BANanoElement, Props As Map)
	mTarget = Target

	If Props <> Null Then
		' set common properties
		S.SetProps(Props)
		' set component specific properties
		mWidth = Props.Get("Width")
		mHeight = Props.Get("Height")
		mBackgroundColor = Props.Get("BackgroundColor")
		mPenColor = Props.Get("PenColor")
	End If
	
	Dim exStyle As String = BuildExStyle
	
	mElement = mTarget.Append($"<canvas id="${mName}" width=${mWidth} height=${mHeight} class="banSigPad ${mClasses}" style="${exStyle}${mStyle}">"$).Get("#" & mName)
	mSignaturePad.Initialize2("SignaturePad", Array(mElement.ToObject, CreateMap("backgroundColor": mBackgroundColor, "penColor": mPenColor)))
End Sub

public Sub AddToParent(targetID As String)
	mTarget = BANano.GetElement("#" & targetID.ToLowerCase)
	DesignerCreateView(mTarget, Null)
End Sub

public Sub Remove()
	Pauze
	mTarget.Empty
	BANano.SetMeToNull
End Sub

#Region common shared properties and methods
public Sub Trigger(event As String, params() As String)
	S.Trigger(mElement, event, params)
End Sub

public Sub BuildExStyle() As String
	Return S.BuildExStyle
End Sub

public Sub setClasses(Classes As String)
	S.SetClasses(mElement, Classes)
End Sub

public Sub getClasses() As String
	Return S.GetClasses
End Sub

' must be a json string
' e.g. $"{ "width": "200px", "height": "200px", "background": "green", "border-radius": "5px" }"$
public Sub setStyle(Style As String)
	S.SetStyle(mElement,Style)
End Sub

public Sub getStyle() As String
	Return S.GetStyle
End Sub

public Sub setVisible(Visible As Boolean)
	S.SetVisible(mElement, Visible)
End Sub

public Sub getVisible() As Boolean
	Return S.GetVisible(mElement)
End Sub

public Sub setEnabled(Enabled As Boolean)
	S.SetEnabled(mElement, Enabled)
End Sub

public Sub getEnabled() As Boolean
	Return S.GetEnabled(mElement)
End Sub
#End Region

public Sub Clear()
	mSignaturePad.RunMethod("clear", Null)
End Sub

public Sub IsEmpty() As Boolean
	Return mSignaturePad.RunMethod("isEmpty", Null).Result
End Sub

' unbinds all event handlers
public Sub Pauze()
	mSignaturePad.RunMethod("off", Null)
End Sub

' binds all event handlers
public Sub Resume()
	mSignaturePad.RunMethod("resume", Null)
End Sub

public Sub FromDate(data() As Object)
	mSignaturePad.RunMethod("fromData", data)
End Sub

public Sub ToData() As Object()
	Return mSignaturePad.RunMethod("toData", Null).Result
End Sub

public Sub FromDataURL(dataUrl As String)
	mSignaturePad.RunMethod("fromDataURL", dataUrl)
End Sub

public Sub ToDataURLPNG() As String
	Return mSignaturePad.RunMethod("toDataURL", Null).Result
End Sub

public Sub ToDataURLJPG() As String
	Return mSignaturePad.RunMethod("toDataURL", "image/jpeg").Result
End Sub

public Sub ToDataURLSVG() As String
	Return mSignaturePad.RunMethod("toDataURL", "image/svg+xml").Result
End Sub

#Region Internal Events

#End Region

