﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8
@EndOfDesignText@
'Custom BANano View class

'Uncomment the events you want to show to the user and implement the HandleEvents in DesignerCreateView 
'#Event: Focus (event As BANanoEvent)
'#Event: Blur (event As BANanoEvent)
'#Event: Resize (event As BANanoEvent)
'#Event: Scroll (event As BANanoEvent)
'#Event: Keydown (event As BANanoEvent)
'#Event: KeyPress (event As BANanoEvent)
'#Event: KeyUp (event As BANanoEvent)
#Event: Click (tabIndex as int)
'#Event: ContextMenu (event As BANanoEvent)
'#Event: Dblclick (event As BANanoEvent)
'#Event: MouseDown (event As BANanoEvent)
'#Event: MouseEnter (event As BANanoEvent)
'#Event: MouseLeave (event As BANanoEvent)
'#Event: MouseMove (event As BANanoEvent)
'#Event: MouseOver (event As BANanoEvent)
'#Event: MouseOut (event As BANanoEvent)
'#Event: MouseUp (event As BANanoEvent)
'#Event: Wheel (event As BANanoEvent)
'#Event: Drag (event As BANanoEvent)
'#Event: DragEnd (event As BANanoEvent)
'#Event: DragEnter (event As BANanoEvent)
'#Event: DragStart (event As BANanoEvent)
'#Event: DragLeave (event As BANanoEvent)
'#Event: DragOver (event As BANanoEvent)
'#Event: Drop (event As BANanoEvent)
'#Event: TouchCancel (event As BANanoEvent)
'#Event: TouchEnd (event As BANanoEvent)
'#Event: TouchEnter (event As BANanoEvent)
'#Event: TouchLeave (event As BANanoEvent)
'#Event: TouchMove (event As BANanoEvent)
'#Event: TouchStart (event As BANanoEvent)
'#Event: Change (event As BANanoEvent)

' Properties that will be show in the ABStract Designer.  They will be passed in the props map in DesignerCreateView (Case Sensitive!)
#DesignerProperty: Key: Classes, DisplayName: Classes, FieldType: String, DefaultValue: , Description: Classes added to the HTML tag.
#DesignerProperty: Key: Style, DisplayName: Style, FieldType: String, DefaultValue: , Description: Styles added to the HTML tag. Must be a json String.
#DesignerProperty: Key: MarginLeft, DisplayName: Margin Left, FieldType: String, DefaultValue: , Description: Margin Left
#DesignerProperty: Key: MarginRight, DisplayName: Margin Right, FieldType: String, DefaultValue: , Description: Margin Right
#DesignerProperty: Key: MarginTop, DisplayName: Margin Top, FieldType: String, DefaultValue: , Description: Margin Top
#DesignerProperty: Key: MarginBottom, DisplayName: Margin Bottom, FieldType: String, DefaultValue: , Description: Margin Bottom
#DesignerProperty: Key: PaddingLeft, DisplayName: Padding Left, FieldType: String, DefaultValue: , Description: Padding Left
#DesignerProperty: Key: PaddingRight, DisplayName: Padding Right, FieldType: String, DefaultValue: , Description: Padding Right
#DesignerProperty: Key: PaddingTop, DisplayName: Padding Top, FieldType: String, DefaultValue: , Description: Padding Top
#DesignerProperty: Key: PaddingBottom, DisplayName: Padding Bottom, FieldType: String, DefaultValue: , Description: Padding Bottom
#DesignerProperty: Key: Enabled, DisplayName: Enabled, FieldType: Boolean, DefaultValue: True, Description: If enabled.
#DesignerProperty: Key: Visible, DisplayName: Visible, FieldType: Boolean, DefaultValue: True, Description: If visible.

#DesignerProperty: Key: Tabs, DisplayName: Tabs, FieldType: String, DefaultValue: , Description: A ; delimted string with tab titles
#DesignerProperty: Key: ActiveTab, DisplayName: Active Tab index, FieldType: Int, DefaultValue: 0, Description: Index of the tab that is active
#DesignerProperty: Key: HideTabs, DisplayName: Hide Tabs, FieldType: Boolean, DefaultValue: False, Description: Hide the tabs on top and use only the content panels.
Sub Class_Globals
	Private BANano As BANano 'ignore
	Private S As SKShared
	Private mName As String 'ignore
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mTarget As BANanoElement 'ignore
	Private mElement As BANanoElement 'ignore
	Private mElementContents As BANanoElement 'ignore
		
	Private mClasses As String = ""
	Private mStyle As String = ""
	Public MarginLeft As String = ""
	Public MarginRight As String = ""
	Public MarginTop As String = ""
	Public MarginBottom As String = ""
	Public PaddingLeft As String = ""
	Public PaddingRight As String = ""
	Public PaddingTop As String = ""
	Public PaddingBottom As String = ""
	Private mVisible As Boolean = True
	Private mEnabled As Boolean = True
	Private mHideTabs As Boolean = False
	
	Private mTabs As String = ""
	Private mActiveTab As Int = 0
	Private mTabElements() As BANanoElement
	Private mTabContents() As BANanoElement
End Sub

Public Sub Initialize (CallBack As Object, Name As String, EventName As String)
	mName = Name.ToLowerCase
	mEventName = EventName.ToLowerCase
	mCallBack = CallBack
	S.Initialize(Me)
End Sub

' returns the BANanoElement
public Sub getElement() As BANanoElement
	Return mElement
End Sub

' returns the tag id
public Sub getID() As String
	Return mName
End Sub

' this is the place where you create the view in html and run initialize javascript
Public Sub DesignerCreateView (Target As BANanoElement, Props As Map)
	mTarget = Target

	If Props <> Null Then
		' set common properties
		S.SetProps(Props)
		' set component specific properties
		mHideTabs = Props.Get("HideTabs")		
		mTabs = Props.Get("Tabs")
		mActiveTab = Props.Get("ActiveTab")
	End If
	
	Dim exStyle As String = BuildExStyle
	
	Dim tabV As String
	Dim tabC As String
	Dim tabValues() As String
	Dim Active As String
	tabValues = BANano.Split(";", mTabs)
	For i = 0 To tabValues.Length - 1		
		Active = ""
		If i = mActiveTab Then
			Active = "active"
		End If
		tabV = tabV & $"<li><a class="button ${Active}" id="${mName}_${i}" href="#${mName}_${i}content">${tabValues(i)}</a></li><span id="${mName}_${i}badge" class="badge"></span>"$
		tabC = tabC & $"<div class="tab-pane ${Active}" id="${mName}_${i}content"></div>"$
	Next
	
	' if you start a SmartString with [BANCLEAN] then BANano will remove all enters, tabs, etc while Transpiling
	Dim tmpHideTabs As String
	If mHideTabs Then
		tmpHideTabs = "u-hide"
	End If
	mElement = mTarget.Append($"<ul id="${mName}" class="tab-nav ${tmpHideTabs} ${mClasses}" style="${exStyle}${mStyle}">${tabV}</ul>"$).Get("#" & mName)
	mElementContents = mTarget.Append($"<div id="${mName}content" class="tab-content">${tabC}</div>"$).Get("#" & mName & "content")
	setEnabled(mEnabled)
	setVisible(mVisible)
	
	'' defining events is very simple. Note that it has to be run AFTER adding it to the HTML DOM! eventName must be lowercase!	
	mTabElements = mElement.Children("li")
	For i = 0 To mTabElements.Length - 1
		Dim mAs() As BANanoElement = mTabElements(i).Children("a")
		mTabElements(i) = mAs(0)
		mTabElements(i).HandleEvents("click", Me, "handleclick")
	Next	
	mTabContents = mElementContents.Children("div.tab-pane")
End Sub

public Sub AddToParent(targetID As String)
	mTarget = BANano.GetElement("#" & targetID.ToLowerCase)
	DesignerCreateView(mTarget, Null)
End Sub

public Sub Remove()
	mElement.Remove
	mElementContents.Remove
	BANano.SetMeToNull
End Sub

#Region common shared properties and methods
public Sub Trigger(event As String, params() As String)
	S.Trigger(mElement, event, params)
End Sub

public Sub BuildExStyle() As String
	Return S.BuildExStyle
End Sub

public Sub setClasses(Classes As String)
	S.SetClasses(mElement, Classes)
End Sub

public Sub getClasses() As String
	Return S.GetClasses
End Sub

' must be a json string
' e.g. $"{ "width": "200px", "height": "200px", "background": "green", "border-radius": "5px" }"$
public Sub setStyle(Style As String)
	S.SetStyle(mElement,Style)
End Sub

public Sub getStyle() As String
	Return S.GetStyle
End Sub

public Sub setVisible(Visible As Boolean)
	S.SetVisible(mElement, Visible)
End Sub

public Sub getVisible() As Boolean
	Return S.GetVisible(mElement)
End Sub

public Sub setEnabled(Enabled As Boolean)
	S.SetEnabled(mElement, Enabled)
End Sub

public Sub getEnabled() As Boolean
	Return S.GetEnabled(mElement)
End Sub
#End Region

public Sub GetTabContents(index As Int) As BANanoElement
	Return mTabContents(index)
End Sub

public Sub GetTab(index As Int) As BANanoElement
	Return mTabElements(index)
End Sub

public Sub GetTabBadge(index As Int) As String
	Dim tmpTab As BANanoElement = mTabElements(index)
	Dim tmpBadge As BANanoElement
	tmpBadge.Initialize("#" & tmpTab.Name & "badge")
	Return tmpBadge.GetText
End Sub

public Sub SetTabBadge(index As Int, value As String)
	Dim tmpTab As BANanoElement = mTabElements(index)
	Dim tmpBadge As BANanoElement
	tmpBadge.Initialize("#" & tmpTab.Name & "badge")
	tmpBadge.SetText(value)
End Sub

public Sub GotoTab(index As Int)
	mTabElements(mActiveTab).RemoveClass("active")
	mTabContents(mActiveTab).RemoveClass("active")	
	mTabElements(index).AddClass("active")
	mTabContents(index).AddClass("active")
	mActiveTab = index
End Sub

#Region Internal Events
public Sub HandleClick(event As BANanoEvent)
	If mEnabled Then		
		Dim src As String = event.OtherField("srcElement").GetField("id").Result		
		Dim j As Int = src.LastIndexOf("_")
		If j > 0 Then
			src = src.SubString(j+1)
			Dim CurrentTag As Int = BANano.parseInt(src)
			
			If mActiveTab = CurrentTag Then
				BANano.CallSub(mCallBack, mEventName & "_click", Array(mActiveTab))
				Return
			End If
			
			mTabElements(mActiveTab).RemoveClass("active")
			mTabContents(mActiveTab).RemoveClass("active")
			
			mTabElements(CurrentTag).AddClass("active")
			mTabContents(CurrentTag).AddClass("active")
			mActiveTab = CurrentTag
		End If
		
		BANano.CallSub(mCallBack, mEventName & "_click", Array(mActiveTab))
	End If
End Sub
#End Region



