﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=8
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private BANano As BANano 'ignore
	Private CSS As String
	Private mBaseColor As String = "#33C3F0"
	Private mDatePickerHoverColor As String = "#336e9c"
	Private mDatePickerSelectedColor As String = "#336e9c"
	Private mBadgeBackColor As String = "#c0392b"	
End Sub

private Sub Initialize() 'ignore
	
End Sub

' toastType: default, success, danger, warning, info
' timeout: a number in ms, or true/false
public Sub ShowToast(message As String, toastType As String, timeout As Object, dismissible As Boolean)
	Dim options As Map
	options.Initialize
	options.Put("message", message)
	options.Put("fixed", True)
	If toastType <> "" And toastType <> "default" Then
		options.Put("status", toastType)
	End If
	If timeout <> Null And timeout <> False Then
		options.Put("timeout", timeout)
	End If
	options.Put("dismissible", dismissible)
			
	Dim toast As BANanoObject
	toast.Initialize4("SnackBar", options)
End Sub

#If B4J
' sets the primary color of all components. Must be done in AppStart.
public Sub SetBaseColor(baseColor As String)
	mBaseColor = baseColor
End Sub

' sets the hover color for the datapicker. Must be done in AppStart.
public Sub SetDatePickerHoverColor(DatePickerHoverColor As String)
	mDatePickerHoverColor = DatePickerHoverColor
End Sub

' sets the color of the selected date in the datepicker. Must be done in AppStart.
public Sub SetDatePickerSelectedColor(DatePickerSelectedColor As String)
	mDatePickerSelectedColor = DatePickerSelectedColor
End Sub

' sets backcolor for the badge on SKTabs and SKMobileNav
public Sub SetBadgeBackColor(badgeBackColor As String)
	mBadgeBackColor = badgeBackColor
End Sub

' sets the offset from the bottom of the floating button. Must be done in AppStart.
public Sub SetFloatingButtonBottom(bottomInPx As Int)
	CSS = CSS & $".skfab{
    bottom:${bottomInPx}px;
}
.inner-fabs .skfab{   
    bottom:${(bottomInPx+8)}px;    
}
.inner-fabs.show .skfab:nth-child(1){
    bottom:${bottomInPx+65}px
}
.inner-fabs.show .skfab:nth-child(2){
    bottom:${bottomInPx+65+50}px
}
.inner-fabs.show .skfab:nth-child(3){
    bottom:${bottomInPx+65+100}px
}
.inner-fabs.show .skfab:nth-child(4){
    bottom:${bottomInPx+65+150}px
}
.inner-fabs.show .skfab:nth-child(5){
    bottom:${bottomInPx+65+200}px
}
.inner-fabs.show .skfab:nth-child(6){
    bottom:${bottomInPx+65+250}px
}
.inner-fabs.show .skfab:nth-child(7){
    bottom:${bottomInPx+65+300}px
}"$
End Sub

' writes the theme css file to disk and adds it to the header. Must be done in AppStart.
public Sub WriteTheme()
	CSS = CSS & $".button.button-primary,button.button-primary,input[type="submit"].button-primary,input[type="reset"].button-primary,input[type="button"].button-primary{
    background-color:${mBaseColor} !important;
    border-color:${mBaseColor} !important;
}
input[type="email"]:focus,input[type="number"]:focus,input[type="search"]:focus,input[type="text"]:focus,input[type="tel"]:focus,input[type="url"]:focus,input[type="password"]:focus,textarea:focus,select:focus{
    border:1px solid ${mBaseColor} !important;
}
.alert,.badge,.switch input[type=checkbox]~label:before{
    background-color:${mBaseColor} !important;    
}
.button:active,.checkbox label:before,.radio label:before,.switch .switch-button,.switch label:before{
    border-color:${mBaseColor} !important;
    color:${mBaseColor} !important;
}
.checkbox input[type=checkbox]:checked~label:before{
    color:${mBaseColor} !important;
}
.radio input[type=radio]:checked~label:before{
    background-color:${mBaseColor} !important;
}
.switch label:before{
    background-color:${mBaseColor} !important;    
}
input[type=range]:active::-webkit-slider-thumb{
    border:1px solid ${mBaseColor} !important;
}
input[type=range]:active::-moz-range-thumb{
    border:1px solid ${mBaseColor} !important;
}
.skfab{
    background-color:${mBaseColor} !important;    
}
.sk-chip-head{
    background-color:${mBaseColor} !important;    
}
.sk-mobile-nav-item-active{
    background-color:${mBaseColor} !important;
}
.is-today .pika-button{
    color:${mBaseColor} !important;
 }
.has-event .pika-button,.is-selected .pika-button{
    background:${mDatePickerSelectedColor} !important; 
}
.is-endrange .pika-button{
    background:${mBaseColor} !important; 
}
.pika-single {
    border: 1px solid ${mBaseColor} !important; 
    border-bottom-color: ${mBaseColor} !important;     
}
.pika-button:hover,.pika-row.pick-whole-week:hover .pika-button{
    background:${mDatePickerHoverColor} !important; 
}
.skcrumbs ul li a:hover {
  background: ${mBaseColor};
  color: #fff;
}
.skcrumbs ul li a:hover:after {
  border-left-color: ${mBaseColor};
  color: #fff;
}
.ql-snow.ql-toolbar button:hover,
.ql-snow .ql-toolbar button:hover,
.ql-snow.ql-toolbar button:focus,
.ql-snow .ql-toolbar button:focus,
.ql-snow.ql-toolbar button.ql-active,
.ql-snow .ql-toolbar button.ql-active,
.ql-snow.ql-toolbar .ql-picker-label:hover,
.ql-snow .ql-toolbar .ql-picker-label:hover,
.ql-snow.ql-toolbar .ql-picker-label.ql-active,
.ql-snow .ql-toolbar .ql-picker-label.ql-active,
.ql-snow.ql-toolbar .ql-picker-item:hover,
.ql-snow .ql-toolbar .ql-picker-item:hover,
.ql-snow.ql-toolbar .ql-picker-item.ql-selected,
.ql-snow .ql-toolbar .ql-picker-item.ql-selected {
  color: ${mBaseColor};
}
.ql-snow.ql-toolbar button:hover .ql-fill,
.ql-snow .ql-toolbar button:hover .ql-fill,
.ql-snow.ql-toolbar button:focus .ql-fill,
.ql-snow .ql-toolbar button:focus .ql-fill,
.ql-snow.ql-toolbar button.ql-active .ql-fill,
.ql-snow .ql-toolbar button.ql-active .ql-fill,
.ql-snow.ql-toolbar .ql-picker-label:hover .ql-fill,
.ql-snow .ql-toolbar .ql-picker-label:hover .ql-fill,
.ql-snow.ql-toolbar .ql-picker-label.ql-active .ql-fill,
.ql-snow .ql-toolbar .ql-picker-label.ql-active .ql-fill,
.ql-snow.ql-toolbar .ql-picker-item:hover .ql-fill,
.ql-snow .ql-toolbar .ql-picker-item:hover .ql-fill,
.ql-snow.ql-toolbar .ql-picker-item.ql-selected .ql-fill,
.ql-snow .ql-toolbar .ql-picker-item.ql-selected .ql-fill,
.ql-snow.ql-toolbar button:hover .ql-stroke.ql-fill,
.ql-snow .ql-toolbar button:hover .ql-stroke.ql-fill,
.ql-snow.ql-toolbar button:focus .ql-stroke.ql-fill,
.ql-snow .ql-toolbar button:focus .ql-stroke.ql-fill,
.ql-snow.ql-toolbar button.ql-active .ql-stroke.ql-fill,
.ql-snow .ql-toolbar button.ql-active .ql-stroke.ql-fill,
.ql-snow.ql-toolbar .ql-picker-label:hover .ql-stroke.ql-fill,
.ql-snow .ql-toolbar .ql-picker-label:hover .ql-stroke.ql-fill,
.ql-snow.ql-toolbar .ql-picker-label.ql-active .ql-stroke.ql-fill,
.ql-snow .ql-toolbar .ql-picker-label.ql-active .ql-stroke.ql-fill,
.ql-snow.ql-toolbar .ql-picker-item:hover .ql-stroke.ql-fill,
.ql-snow .ql-toolbar .ql-picker-item:hover .ql-stroke.ql-fill,
.ql-snow.ql-toolbar .ql-picker-item.ql-selected .ql-stroke.ql-fill,
.ql-snow .ql-toolbar .ql-picker-item.ql-selected .ql-stroke.ql-fill {
  fill: ${mBaseColor};
}
.ql-snow.ql-toolbar button:hover .ql-stroke,
.ql-snow .ql-toolbar button:hover .ql-stroke,
.ql-snow.ql-toolbar button:focus .ql-stroke,
.ql-snow .ql-toolbar button:focus .ql-stroke,
.ql-snow.ql-toolbar button.ql-active .ql-stroke,
.ql-snow .ql-toolbar button.ql-active .ql-stroke,
.ql-snow.ql-toolbar .ql-picker-label:hover .ql-stroke,
.ql-snow .ql-toolbar .ql-picker-label:hover .ql-stroke,
.ql-snow.ql-toolbar .ql-picker-label.ql-active .ql-stroke,
.ql-snow .ql-toolbar .ql-picker-label.ql-active .ql-stroke,
.ql-snow.ql-toolbar .ql-picker-item:hover .ql-stroke,
.ql-snow .ql-toolbar .ql-picker-item:hover .ql-stroke,
.ql-snow.ql-toolbar .ql-picker-item.ql-selected .ql-stroke,
.ql-snow .ql-toolbar .ql-picker-item.ql-selected .ql-stroke,
.ql-snow.ql-toolbar button:hover .ql-stroke-miter,
.ql-snow .ql-toolbar button:hover .ql-stroke-miter,
.ql-snow.ql-toolbar button:focus .ql-stroke-miter,
.ql-snow .ql-toolbar button:focus .ql-stroke-miter,
.ql-snow.ql-toolbar button.ql-active .ql-stroke-miter,
.ql-snow .ql-toolbar button.ql-active .ql-stroke-miter,
.ql-snow.ql-toolbar .ql-picker-label:hover .ql-stroke-miter,
.ql-snow .ql-toolbar .ql-picker-label:hover .ql-stroke-miter,
.ql-snow.ql-toolbar .ql-picker-label.ql-active .ql-stroke-miter,
.ql-snow .ql-toolbar .ql-picker-label.ql-active .ql-stroke-miter,
.ql-snow.ql-toolbar .ql-picker-item:hover .ql-stroke-miter,
.ql-snow .ql-toolbar .ql-picker-item:hover .ql-stroke-miter,
.ql-snow.ql-toolbar .ql-picker-item.ql-selected .ql-stroke-miter,
.ql-snow .ql-toolbar .ql-picker-item.ql-selected .ql-stroke-miter {
  stroke: ${mBaseColor};
}
.ql-snow a {
  color: ${mBaseColor};
}
.js-snackbar__status.js-snackbar--info{
	background-color:${mBaseColor}
}
.sk-dd-button.button-primary:after{
	border-top:5px solid #FFF;
}
.sk-dd-button.button-primary {
	color:#FFF;background-color:${mBaseColor};
}
.sk-pagination .sk-pagination-item.short.selected {
    background-color: ${mBaseColor};
}
.sk-pagination .sk-pagination-item:hover p,
.sk-pagination .sk-pagination-item:hover h1,
.sk-pagination .sk-pagination-item:hover h2,
.sk-pagination .sk-pagination-item:hover h3,
.sk-pagination .sk-pagination-item:hover h4,
.sk-pagination .sk-pagination-item:hover h5,
.sk-pagination .sk-pagination-item:hover h6,
.sk-pagination .sk-pagination-item:not(.selected):hover *:not([disabled]):not(.ellipses) {
    color: ${mBaseColor};
}
.badge {
	background-color: ${mBadgeBackColor} !important;
}
.navbadge {
	background-color: ${mBadgeBackColor} !important;
}"$
	Dim cssFileName As String = "theme.css"
	Dim Path As String = File.GetFileParent(File.DirApp) & "/Files/"
	
	Dim txtOUT As TextWriter
	txtOUT.Initialize(File.OpenOutput(Path, cssFileName, False))
	txtOUT.Write(CSS)
	txtOUT.Close
	
	BANano.Header.AddCSSFile(cssFileName)
End Sub
#End If
