﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=6.51
@EndOfDesignText@
' TIP: you make it yourself a lot easier if you LowerCase all the IDs!

Sub Process_Globals
	Dim BANano As BANano 'ignore	
End Sub

public Sub AddRows(RowIDPrefix As String, Rows As Int) As List
	Dim l As List
	l.Initialize
	For i = 1 To Rows
		Dim myRow As Row
		myRow.Initialize(RowIDPrefix.ToLowerCase & i)
		l.Add(myRow)
	Next
	Return l
End Sub

public Sub AddColumns(CellIDPrefix As String, theRow As Row, Cells As Int, classes As String)
	For i = 1 To Cells
		Dim myCol As Col
		myCol.Initialize(theRow.ID & CellIDPrefix.ToLowerCase & i, classes)
		theRow.cols.Add(myCol)
	Next
End Sub

public Sub BuildGrid(targetID As String, Rows As List)
	Dim Grid As StringBuilder
	Grid.Initialize
	Grid.Append($"<div class="container">"$)
	For i = 0 To Rows.Size - 1
		Dim myRow As Row = Rows.Get(i)
		Grid.Append($"<div id="${myRow.ID}" class="row">"$)
		For j = 0 To myRow.Cols.Size - 1
			Dim myCol As Col = myRow.Cols.Get(j)
			Grid.Append($"<div id="${myCol.ID}" class="${myCol.Classes}"></div>"$)
		Next
		Grid.Append($"</div>"$)
	Next
	Grid.Append($"</div>"$)
	BANano.GetElement(targetID.ToLowerCase).setHTML(Grid.toString)
End Sub

public Sub Content(TargetID As String, ID As String, Text As String)
	BANano.GetElement(TargetID.ToLowerCase).RenderAppend( $"<p id="${ID.ToLowerCase}">"$ & Text & "</p>","")
End Sub

public Sub Header(TargetID As String, ID As String, Level As Int, Text As String)
	BANano.GetElement(TargetID.ToLowerCase).RenderAppend($"<h${Level} id="${ID.ToLowerCase}">${Text}</h${Level}>"$,"")
End Sub

Public Sub Button(TargetID As String, ID As String, Text As String, ColorVariant As String, EventHandler As Object)
	Dim tgt As BANanoElement = GetElement(TargetID)
	Dim btn() As BANanoElement = tgt.RenderAppend($"<button id="${ID.ToLowerCase}" class="${ColorVariant}">${Text}</button>"$,"").Children("")
	' defining events is very simple. Note that it has to be run AFTER adding it to the HTML DOM!
	' eventName must be lowercase!
	If EventHandler <> Null Then
		btn(0).HandleEvents("mousedown, touchstart", EventHandler, "buttonclicked")
	End If
End Sub

Sub GetElement(ID As String) As BANanoElement
	ID = ID.ToLowerCase
	Return BANano.GetElement(ID)
End Sub

public Sub Image(TargetID As String, ID As String, Src As String, AltText As String)
	BANano.GetElement(TargetID.ToLowerCase).Render($"<img id="${ID.ToLowerCase}" src="${Src}" alt="${AltText}"/>"$, "")
End Sub

public Sub LoginForm(TargetID As String, ID As String, EventHandler As Object)
	Dim template As String = $"<form id="${ID.ToLowerCase}">
  <fieldset>
    <legend>Simple form</legend>
	<div class="row">
      <div class="col-sm-12 col-md-6">
        <label for="username">Username</label>
        <input id="${ID.ToLowerCase}myusername" type="text" placeholder="Username" class="inputkeys"/>
      </div>
      <div class="col-sm-12 col-md-6">
        <label for="password">Password</label>
        <input  id="${ID.ToLowerCase}mypassword" type="password" placeholder="Password" class="inputkeys"/>
      </div>
    </div>
  </fieldset>
</form>"$
	BANano.GetElement(TargetID.ToLowerCase).Render(template, "")

	Dim inp As BANanoElement = BANano.GetElement(".inputkeys")
		
	' defining events is very simple. Note that it has to be run AFTER adding it to the HTML DOM!
	' eventName must be lowercase!
	inp.On("keydown", EventHandler, "inp_keydown")
	inp.On("keyup", EventHandler, "inp_keyup")
End Sub