﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=7
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Public BANano As BANano
	Public AllStrings As Map	
End Sub

public Sub LoadLanguageFile(Url As String) 'ignore
	' We make a new promise
	Dim promise As BANanoPromise 'ignore
	' Some vars to hold our results
	Dim json As String
	Dim error As String
 
	' Call the http request
	promise.CallSub(Me, "DoHTTPForUrl", Array(Url))
 
	promise.Then(json)
		' We got it!
		AllStrings = BANano.FromJson(json)
		' Get the menu part
		Dim menu As Map = AllStrings.Get("menu")
		' We use SetMenu here to replace the texts, not AddMenu
		Main.SKNavigationBar1.SetMenu("Links", menu.Get("Links"))
		Main.SKNavigationBar1.SetMenu("NearPlaces", menu.Get("NearPlaces"))
		Main.SKNavigationBar1.SetMenu("Prices", menu.Get("Prices"))
		Main.SKNavigationBar1.SetMenu("Services", menu.Get("Services"))
		Main.SKNavigationBar1.SetMenu("About", menu.Get("About"))
		Main.SKNavigationBar1.SetMenu("Home", menu.Get("Home"))
		' Use the new translations on the current page
		LoadTexts
	promise.Else(error)
		Log(error)	
	promise.end
End Sub

public Sub LoadTexts()
	' Get the current page info from our router
	Dim PageName As String = Main.Router.PageName
	Dim UniqueID As String = Main.Router.UniqueID
	
	Dim PageStrings As Map = AllStrings.Get(PageName)
	
	' For all the keys in the json map
	For Each key As String In PageStrings.Keys
		Dim prefix As String = key.SubString2(0,3)
		' We use the prefix to find out what kind of Custom View it is.
		Select Case prefix
			Case "lbl"
				Dim lbl As SKLabel = BANano.GetViewFromLayoutArray(Main.Router.Page, PageName, key, UniqueID)
				lbl.Text = PageStrings.Get(key)
			Case "lst"
				Dim lst As SKList = BANano.GetViewFromLayoutArray(Main.Router.Page, PageName, key, UniqueID)
				lst.Clear
				Dim itemsStr As String = PageStrings.Get(key)
				Dim items() As String = BANano.Split(";", itemsStr)
				For i = 0 To items.length - 1
					lst.AppendToList(items(i), Null, False)
				Next
		End Select
	Next
	
	' Go to the top of the page
	BANano.Window.ScrollTo(0,0)
End Sub

public Sub DoHTTPForUrl(Url As String) As String 'ignore
	' Defining a XMLHttpRequest object
	Dim Request As BANanoObject
	Request.Initialize2("XMLHttpRequest", Null)
	
	' Running a get
	Request.RunMethod("open", Array("GET", Url))
		
	' Defining the onload and onerror callbacks
	Dim event As Map
	' Careful here: we have to use the event name without the 'on' prefix when using AddEventListener
	Request.AddEventListener("load", BANano.CallBack(Me, "OnLoadHTTP", event), True)
	Request.AddEventListener("error", BANano.CallBack(Me, "OnErrorHTTP", event), True)
	
	' Let's do it!
	Request.RunMethod("send", Null)
End Sub

public Sub OnloadHTTP(event As Map)
	' Getting our XmlHttpRequest object again
	Dim Request As BANanoObject = event.Get("target")
	
	' Checking the status
	Dim status As Int = Request.GetField("status").Result
	If status < 200 Or status >= 300 Then
		' Maybe not allowed? Return an error with ReturnElse
		BANano.ReturnElse("Status code was not 200!")
	Else
		' All is fine, return a Then
		BANano.ReturnThen(Request.GetField("response").Result)
	End If
End Sub

public Sub OnErrorHTTP(event As Map)
	' Some other error, return a ReturnElse
	BANano.ReturnElse("Network error")
End Sub